DECLARE SUB ovSetMap (Map AS INTEGER)
DECLARE SUB BrowseAround ()
DECLARE FUNCTION YesOrNo% ()
DECLARE SUB SaveIt ()
DECLARE FUNCTION Menu% (which AS STRING, Prmpt$)
DECLARE SUB MenuItemBlue (Itm%)
DECLARE SUB MenuItemGray (Itm%)
DECLARE SUB WaitLetGo ()
DECLARE SUB FileMenu ()
DECLARE SUB BlackPrint (text AS STRING, x%, Y%)
DECLARE FUNCTION AtByte% ()
DECLARE SUB CompressOverworld ()
DECLARE FUNCTION CountMasses% ()
DECLARE SUB DrawGradient ()
DECLARE SUB DispDrawWith ()
DECLARE SUB Actions ()
DECLARE SUB DrawGui ()
DECLARE SUB ScrollCheck ()
DECLARE SUB DisplayOverWorld ()
DECLARE SUB OverworldEditor ()
DECLARE SUB DecompressOverworld ()
DECLARE FUNCTION Prompt$ (pmt AS STRING, ext AS STRING, dft AS STRING)
DECLARE SUB LoadFile ()
DECLARE SUB Finish ()
DECLARE SUB Initalize ()
DECLARE SUB ShadowPrint2 (text AS STRING, x%, Y%)
DECLARE SUB MakeCur ()
DECLARE FUNCTION trimstr$ (value%)
'$INCLUDE: 'directqb.bi'
'$INCLUDE: 'z2pledit.bi'
'$STATIC

DEFINT A-Z

'********************
'
'Varable declaration:
'
'********************

'Map array
DIM SHARED ovmap(63, 75)

'Menu Items
DIM SHARED Item(20) AS STRING, Items, Height

'Coordinates used by editor
DIM SHARED CameraX, CameraY
DIM SHARED Tx, Ty, OldX, OldY, DrawWith, DoDraw

'Overworld Stuff
DIM SHARED ovmapsize, Cursize

'Mouse Cursor
DIM SHARED cur AS STRING * 64

'The Offset of the map data
DIM SHARED ovOffset AS LONG

'NOTE! If you get an "Advanced feature unavailable" Error, add a comment (')
'to the beginning of the next line.
cmd$ = COMMAND$

'Flags
DIM SHARED Scrolled

verbose = true
ScrollMode = true

PRINT : PRINT                 'Make 2 empty lines
twemp = CSRLIN                'Clear
LOCATE twemp, 1               ' out
PRINT SPACE$(160);            '  the
LOCATE twemp, 1               '   junk
PRINT "Zelda 2 overworld Editor, Version " + "DEV 4.3"   'Display program and Version
PRINT "Started on ???, Compiled 4/3/2000, 10:50AM"  'Time and dates

MakeCur

LoadFile   'Gets a filename

Initalize

OverworldEditor

Finish

PRINT "Zelda 2 overworld Editor, Version " + "DEV 4.3"
PRINT "Development Version"

SUB Actions
IF DQBmouseX < 256 THEN
  IF DQBmouseLB = true THEN
    SELECT CASE DrawWith
      CASE 0 TO 15
        ovmap(Tx, Ty) = DrawWith
      CASE 16
        IF DoDraw = False THEN
          IF Tx = 0 THEN EXIT SUB
          ovmap(Tx, Ty) = (ovmap(Tx, Ty) + 16) AND 31
          IF (ovmap(Tx - 1, Ty) AND 15) <> (ovmap(Tx, Ty) AND 15) THEN ovmap(Tx, Ty) = ovmap(Tx, Ty) AND 15
        END IF
    END SELECT

    Z1 = (ovmap(Tx, Ty) AND 15) * 16
    x1 = (Tx - CameraX) * 16
    y1 = (Ty - CameraY) * 16
   
    DqbGet 5, Z1, 0, Z1 + 15, 15, VARSEG(tilebuf(0)), VARPTR(tilebuf(0))
    DqbPut 2, x1, y1, VARSEG(tilebuf(0)), VARPTR(tilebuf(0))
    IF ovmap(Tx, Ty) > 15 THEN
      Dqbline 2, x1, y1, x1 + 13, y1, 10
      Dqbline 2, x1, y1, x1, y1 + 15, 10
      Dqbline 2, x1, y1 + 15, x1 + 13, y1 + 15, 10
    END IF
   
    Cursize = CountMasses
    DoDraw = true

  END IF
  IF DQBmouseRB = true THEN DrawWith = ovmap(Tx, Ty) AND 15
ELSE
  IF DQBmouseLB = true OR DQBmouseRB = true THEN
    IF DQBmouseY > 5 AND DQBmouseY < 18 * 8 + 6 THEN
      IF DQBmouseX > 256 + 15 AND DQBmouseX < 256 + 32 THEN
        DrawWith = (DQBmouseY - 6) \ 18
      END IF
      IF DQBmouseX > 256 + 31 AND DQBmouseX < 256 + 49 THEN
        DrawWith = (DQBmouseY - 6) \ 18 + 8
      END IF
    END IF
    IF DQBmouseY > 150 AND DQBmouseY < 167 AND DQBmouseX > 256 + 15 AND DQBmouseX < 256 + 32 THEN
      DrawWith = 16
    END IF
    IF DQBmouseY >= 186 AND DQBmouseY < 195 AND DQBmouseX > 264 AND DQBmouseX < 311 THEN
      FileMenu
    END IF
  END IF
END IF

DispDrawWith


END SUB

FUNCTION AtByte

Til = ovmap(x, Y)
x = 1
ln = 0
Total = 0

IF Ty = 0 AND Tx = 0 THEN EXIT FUNCTION

DO
    oldtil = newtil
    newtil = ovmap(x, Y) AND 15
    IF newtil = Til THEN
      ln = ln + 1
    ELSE
      Til = ovmap(x, Y) AND 15
      Total = Total + 1
      ln = 0
    END IF
    IF ln = 16 THEN
      Til = ovmap(x, Y) AND 15
      ln = 0
      Total = Total + 1
    END IF
    IF ovmap(x, Y) > 15 AND newtil = oldtil THEN
      Til = ovmap(x, Y) AND 15
      ln = 0
      Total = Total + 1
    END IF
    IF x = Tx AND Y = Ty THEN EXIT DO
    x = x + 1
    IF x = 64 THEN
      x = 1
      Y = Y + 1
      Total = Total + 1
      Til = ovmap(0, Y) AND 15
      ln = 0
      IF Tx = 0 AND Y = Ty THEN EXIT DO
    END IF
    IF Y = 75 THEN EXIT DO
LOOP
AtByte = Total

END FUNCTION

SUB BlackPrint (text AS STRING, x, Y)

DQBPrint 1, text, x, Y, 0

END SUB

SUB BrowseAround
DrawGradient
DIM Xpointer AS LONG, Ypointer AS LONG, Zpointer AS LONG
DIM oldxp AS LONG, oldyp AS LONG, oldzp AS LONG

  pointme = &H462F
  oldp = pointme
  x = 0
  dqbpeek VARSEG(x), VARPTR(x), pointme + &H3F, 1
  Y = 0
  dqbpeek VARSEG(Y), VARPTR(Y), pointme, 1
  Tx = x AND 63: Ty = (Y AND 127) - &H1E
  IF Ty < 0 THEN Ty = 0
  CameraX = Tx - 8
  CameraY = Ty - 5
  IF CameraY < 0 THEN CameraY = 0
  IF CameraX < 0 THEN CameraX = 0
  IF CameraY > 75 - 12 THEN CameraY = 75 - 12
  IF CameraX > 64 - 16 THEN CameraX = 64 - 16
  DQBSetMousePos ((Tx - CameraX) * 16 + 8), ((Ty - CameraY) * 16 + 8)
  DisplayOverWorld
  dqbcopylayer 2, 1

  Px = Tx
  Py = Ty

DO
  dqbcopylayer 2, 1

  x1 = (Tx - CameraX) * 16
  y1 = (Ty - CameraY) * 16
  DqbBox 1, x1, y1, x1 + 15, y1 + 15, 15

  x1 = (Px - CameraX) * 16
  y1 = (Py - CameraY) * 16
  IF x1 > 0 AND x1 < 320 AND y1 > 0 AND y1 < 199 THEN
  DqbBox 1, x1, y1, x1 + 15, y1 + 15, 10
  END IF

  y1 = 2
  ShadowPrint2 "Coordinates:", 258, y1
  y1 = y1 + 6
  ShadowPrint2 "X:" + HEX$(Tx) + "  (" + trimstr$(Tx) + ")", 258, y1
  y1 = y1 + 6
  ShadowPrint2 "Y:" + HEX$(Ty + &H1E) + "  (" + trimstr$(Ty + &H1E) + ")", 258, y1
  y1 = y1 + 6
  ShadowPrint2 "fakeY:" + HEX$(Ty) + "  (" + trimstr$(Ty) + ")", 258, y1
  y1 = y1 + 8
  at = AtByte
  ShadowPrint2 "@" + HEX$(at) + "  (" + HEX$(at + &H7C00) + ")", 258, y1
   
    y1 = y1 + 10
    ShadowPrint2 "Selected Location", 258, y1
    y1 = y1 + 6
    ShadowPrint2 "Properties:", 258, y1
    y1 = y1 + 8
    ShadowPrint2 "Ypointer=" + HEX$(pointme), 258, y1
    y1 = y1 + 6
    ShadowPrint2 "Xpointer=" + HEX$(pointme + &H3F), 258, y1
    y1 = y1 + 6
    ShadowPrint2 "Zpointer=" + HEX$(pointme + &H7E), 258, y1
    y1 = y1 + 6
    ShadowPrint2 "Wpointer=" + HEX$(pointme + &HBD), 258, y1
   
    dqbpeek VARSEG(Y), VARPTR(Y), pointme, 1
    dqbpeek VARSEG(x), VARPTR(x), pointme + &H3F, 1
    dqbpeek VARSEG(Z), VARPTR(Z), pointme + &H7E, 1
    dqbpeek VARSEG(W), VARPTR(W), pointme + &HBD, 1

    y1 = y1 + 8
    ShadowPrint2 "X=" + HEX$(x AND 63), 258, y1
    y1 = y1 + 6
    ShadowPrint2 "IsCaveDest=" + HEX$(x \ 64), 258, y1
    y1 = y1 + 8
    ShadowPrint2 "Y=" + HEX$(Y AND 127), 258, y1
    y1 = y1 + 6
    ShadowPrint2 "External=" + HEX$(Y \ 128), 258, y1
    y1 = y1 + 8
    ShadowPrint2 "Target Map=" + HEX$(Z AND 63), 258, y1
    y1 = y1 + 6
    ShadowPrint2 "Enter Page=" + HEX$(Z \ 64), 258, y1
    y1 = y1 + 8
    ShadowPrint2 "World=" + HEX$(W AND 63), 258, y1
    y1 = y1 + 6
    ShadowPrint2 "Flags=" + HEX$(W \ 63), 258, y1

 
  dqbwait 1
  DQBMouseHide
  dqbcopylayer 1, 0
  dqbMouseShow

  DO
    K$ = UCASE$(INKEY$)
 
    ScrollCheck
  
    Tx = CameraX + (DQBmouseX \ 16)
    IF Tx > CameraX + 15 THEN Tx = CameraX + 15
  
    Ty = CameraY + (DQBmouseY \ 16)
    IF Ty > CameraY + 11 THEN Ty = CameraY + 11

    IF OldX <> Tx OR OldY <> Ty THEN EXIT DO
    IF K$ <> "" THEN EXIT DO
    IF DQBmouseLB = true OR DQBmouseRB = true THEN EXIT DO

  LOOP

    SELECT CASE K$
      CASE CHR$(0) + "K": pointme = pointme - 1
      CASE CHR$(0) + "M": pointme = pointme + 1
    END SELECT
    IF pointme <> oldp THEN
      oldp = pointme
      dqbpeek VARSEG(Y), VARPTR(Y), pointme, 1
      dqbpeek VARSEG(x), VARPTR(x), pointme + &H3F, 1
     
      Tx = x AND 63: Ty = (Y AND 127) - &H1E
      IF Ty < 0 THEN Ty = 0
      CameraX = Tx - 8
      CameraY = Ty - 5
      IF CameraY < 0 THEN CameraY = 0
      IF CameraX < 0 THEN CameraX = 0
      IF CameraY > 75 - 12 THEN CameraY = 75 - 12
      IF CameraX > 64 - 16 THEN CameraX = 64 - 16
     
      Px = Tx
      Py = Ty
     
      DisplayOverWorld
      dqbcopylayer 2, 1
    END IF

  OldX = Tx
  OldY = Ty

  IF DQBmouseX > 256 AND (DQBmouseLB OR DQBmouseRB) THEN EXIT DO

LOOP UNTIL K$ = CHR$(27)

DrawGui

END SUB

SUB CompressOverworld
DIM OldOffset AS LONG

OldOffset = ovOffset

Til = ovmap(x, Y) AND 15
x = 0
ln = 0
Total = 0

DO
    x = x + 1
    IF x = 64 THEN
      x = 1
      Y = Y + 1
      bite = Til + ln * 16
      DQBPoke VARSEG(bite), VARPTR(bite), ovOffset, 1
      ovOffset = ovOffset + 1
      Til = ovmap(0, Y) AND 15
      ln = 0
    END IF
    IF Y = 75 THEN EXIT DO
   
    oldtil = newtil
    newtil = ovmap(x, Y) AND 15
    IF newtil = Til THEN
      ln = ln + 1
    ELSE
      bite = Til + ln * 16
      DQBPoke VARSEG(bite), VARPTR(bite), ovOffset, 1
      ovOffset = ovOffset + 1
      Til = ovmap(x, Y) AND 15
      ln = 0
    END IF
    IF Til = 15 AND ln = 15 THEN
      bite = 255
      DQBPoke VARSEG(bite), VARPTR(bite), ovOffset, 1
      EXIT DO
    END IF
    IF ln = 16 THEN
      bite = Til + 15 * 16
      DQBPoke VARSEG(bite), VARPTR(bite), ovOffset, 1
      ovOffset = ovOffset + 1
      Til = ovmap(x, Y) AND 15
      ln = 0
    END IF
    IF ovmap(x, Y) > 15 AND oldtil = newtil THEN
      bite = Til + (ln - 1) * 16
      DQBPoke VARSEG(bite), VARPTR(bite), ovOffset, 1
      ovOffset = ovOffset + 1
      Til = ovmap(x, Y) AND 15
      ln = 0
    END IF
LOOP

ovOffset = OldOffset

END SUB

FUNCTION CountMasses

Til = ovmap(x, Y)
x = 1
ln = 0
Total = -1

DO
    oldtil = newtil
    newtil = ovmap(x, Y) AND 15
    IF newtil = Til THEN
      ln = ln + 1
    ELSE
      Til = ovmap(x, Y) AND 15
      Total = Total + 1
      ln = 0
    END IF
    IF Til = 15 AND ln = 15 THEN
      Total = Total + 1
      EXIT DO
    END IF
    IF ln = 16 THEN
      Total = Total + 1
      Til = ovmap(x, Y) AND 15
      ln = 0
    END IF
    IF ovmap(x, Y) > 15 AND newtil = oldtil THEN
      Til = ovmap(x, Y) AND 15
      ln = 0
      Total = Total + 1
    END IF
    x = x + 1
    IF x = 64 THEN
      x = 1
      Y = Y + 1
      Total = Total + 1
      Til = ovmap(0, Y) AND 15
      ln = 0
    END IF
    IF Y = 75 THEN EXIT DO
LOOP
CountMasses = Total

END FUNCTION

SUB DecompressOverworld
DIM OldOffset AS LONG
DIM tile, ln, LastTile, LastLn, bite, OnLn
DIM Xp, yp
DIM ForceNew

OldOffset = ovOffset

Xp = 0: yp = 0

tile = -1: ln = 0

DO
  dqbpeek VARSEG(bite), VARPTR(bite), ovOffset, 1
  LastTile = tile
  LastLn = ln
  tile = bite AND 15
  ln = bite \ 16
  IF tile = LastTile AND LastLn < 15 AND Xp > 0 THEN ForceNew = true
 
  FOR OnLn = 0 TO ln
    ovmap(Xp, yp) = tile
    IF ForceNew = true THEN
      ovmap(Xp, yp) = tile + 16
      ForceNew = 0
    END IF
    Xp = Xp + 1
    IF Xp = 64 THEN
      IF ln < OnLn THEN ovOffset = ovOffset - 1
      Xp = 0
      yp = yp + 1
      IF yp = 75 THEN EXIT DO
    END IF
  NEXT
  ovOffset = ovOffset + 1

LOOP UNTIL yp >= 76

'ovmapsize = ovOffset - OldOffset
ovOffset = OldOffset

END SUB

SUB DispDrawWith
 
x1 = 256 + 14 + 18
y1 = 8 + 8 * 18
 
Z1 = DrawWith * 16
DqbGet 5, Z1, 0, Z1 + 15, 15, VARSEG(tilebuf(0)), VARPTR(tilebuf(0))
DqbPut 2, x1, y1, VARSEG(tilebuf(0)), VARPTR(tilebuf(0))

DqbBox 1, x1 - 1, y1 - 1, x1 + 16, y1 + 16, 0

END SUB

SUB DisplayOverWorld
FOR Xp = 0 TO 15
FOR yp = 0 TO 11
  Tl = ovmap(Xp + CameraX, yp + CameraY) AND 15
  x1 = Xp * 16
  y1 = yp * 16
  Z1 = Tl * 16
  DqbGet 5, Z1, 0, Z1 + 15, 15, VARSEG(tilebuf(0)), VARPTR(tilebuf(0))
  DqbPut 2, x1, y1, VARSEG(tilebuf(0)), VARPTR(tilebuf(0))
  IF ovmap(Xp + CameraX, yp + CameraY) > 15 THEN
    'DqbBox 2, x1, y1, x1 + 15, y1 + 15, 10
    Dqbline 2, x1, y1, x1 + 13, y1, 10
    Dqbline 2, x1, y1, x1, y1 + 15, 10
    Dqbline 2, x1, y1 + 15, x1 + 13, y1 + 15, 10
  END IF

NEXT
NEXT
END SUB

SUB DrawGradient

RANDOMIZE TIMER

FOR Y = 1 TO 198
FOR x = 257 TO 318

num = RND * 16
IF num <= Y MOD 14 THEN col = Y \ 14 + 33
IF num > Y MOD 14 THEN col = Y \ 14 + 32
dqbpset 2, x, Y, col

NEXT
NEXT

Dqbline 2, 319, 0, 319, 199, 40   'Right
Dqbline 2, 256, 199, 319, 199, 42 'Bottom
Dqbline 2, 256, 0, 256, 199, 38   'Left
Dqbline 2, 256, 0, 319, 0, 35     'Top


END SUB

SUB DrawGui

DrawGradient

FOR Tl = 0 TO 7
  x1 = 256 + 15
  y1 = Tl * 18 + 8
  Z1 = Tl * 16
  DqbGet 5, Z1, 0, Z1 + 15, 15, VARSEG(tilebuf(0)), VARPTR(tilebuf(0))
  DqbPut 2, x1, y1, VARSEG(tilebuf(0)), VARPTR(tilebuf(0))
NEXT

FOR Tl = 8 TO 15
  x1 = 256 + 33
  y1 = Tl * 18 + 8 - 8 * 18
  Z1 = Tl * 16
  DqbGet 5, Z1, 0, Z1 + 15, 15, VARSEG(tilebuf(0)), VARPTR(tilebuf(0))
  DqbPut 2, x1, y1, VARSEG(tilebuf(0)), VARPTR(tilebuf(0))
NEXT

  Tl = 16
  x1 = 256 + 15
  y1 = 152
  Z1 = Tl * 16
  DqbGet 5, Z1, 0, Z1 + 15, 15, VARSEG(tilebuf(0)), VARPTR(tilebuf(0))
  DqbPut 2, x1, y1, VARSEG(tilebuf(0)), VARPTR(tilebuf(0))

  dqbboxf 2, 264, 186, 311, 195, 7

  DQBPrint 2, "File Menu", 268, 188, 0

  Dqbline 2, 264, 186, 311, 186, 15
  Dqbline 2, 264, 186, 264, 195, 15
 
  Dqbline 2, 311, 186, 311, 195, 8
  Dqbline 2, 264, 195, 311, 195, 8
 
  Dqbline 2, 310, 187, 310, 195, 8
  Dqbline 2, 265, 194, 310, 194, 8

END SUB

SUB FileMenu

DO
  Z = Menu("file", "FILE MENU| |Select an item and|click on it.")

  SELECT CASE Z
    CASE -1: EXIT DO
    CASE 0
      IF CountMasses <= ovmapsize THEN
        CompressOverworld
        SaveIt
        DecompressOverworld
        Z = Menu("OK", "Save Successful!")
        EXIT DO
      ELSE
        PLAY chirp$
        'IF CountMasses < ovmapsize THEN
          'Z = Menu("OK", "Can't Save!| |You must add|more masses|before you can|save!")
        'END IF
        IF CountMasses > ovmapsize THEN
          Z = Menu("OK", "Can't Save!| |You must reduce|the number of|bytes by making|longer strings of|similar tiles.")
        END IF
      END IF
    CASE 1
      IF Menu("YESNO", "Unsaved changes|will be lost!|Proceed?") = 1 THEN
        Z = Menu("select", "Select Map:")
        IF Z >= 0 THEN
          ovSetMap Z
          DecompressOverworld
          DisplayOverWorld
          EXIT DO
        END IF
      END IF
    CASE 2
      IF Menu("YESNO", "Unsaved changes|will be lost!|Proceed?") = 1 THEN
        DecompressOverworld
        DisplayOverWorld
        EXIT DO
      END IF
    CASE 3
      


      '&H479F
    CASE 4
      BrowseAround
    CASE 5
      DQBMouseHide
      DQBClose
      SCREEN 0, 0, 0, 0
      WIDTH 80, 25
      SCREEN 0, 1, 1, 1
      SCREEN 0, 1, 0, 0
      SHELL "Nesticle " + filename
      Initalize
      dqbSetPal ovPal
      DrawGui
      DisplayOverWorld
      DQBMouseHide
      DispDrawWith
      EXIT DO
  END SELECT


LOOP

Cursize = CountMasses

END SUB

DEFSNG A-Z
SUB Finish

DQBClose
SCREEN 0, 0, 1, 1
SCREEN 0, 1, 0, 0
WIDTH 80, 25
SCREEN 0, 0, 1, 1
SCREEN 0, 1, 0, 0

END SUB

SUB Initalize

'Intialize DirectQB

Z = DQBinit(5, 0, 129)
IF Z THEN
  PRINT "Error initalizing DirectQB:"
  PRINT DQBerror$
  END
END IF

'Load the bitmap of tiles

Z = DQBloadImage(5, 0, 0, "z2ovtile.bmp", ovPal, 256, 16)
IF Z THEN
  PRINT "Error loading image 'z2ovtile.bmp':"
  PRINT DQBerror$
  DQBClose
  END
END IF

'Load the font (tiny.fnt)

Z = DQBloadFont("tiny.fnt")
IF Z THEN
  PRINT "Error loading font 'tiny.fnt':"
  PRINT DQBerror$
  DQBClose
  END
END IF

'Set VGA mode 13
SCREEN 13

'And finally load the file:

DIM buff AS STRING * 512

DIM tempoff AS LONG
tempoff = 16
OPEN filename FOR BINARY AS #1
  DO
    GET #1, tempoff + 1, buff
    DQBPoke VARSEG(buff), VARPTR(buff), tempoff, 512
    tempoff = tempoff + 512
    IF tempoff >= 131071 THEN EXIT DO
  LOOP
CLOSE

END SUB

DEFINT A-Z
SUB LoadFile
DIM loaf AS LONG

temp = CSRLIN

back:

IF cmd$ = "" THEN
  filename = Prompt$("File Name:", "NES", "Zelda2Ed.NES")
ELSE
  filename = UCASE$(cmd$)
  IF RIGHT$(filename, 4) <> ".NES" THEN filename = filename + ".NES"
END IF

cmd$ = ""

ffile = FREEFILE
OPEN filename FOR BINARY AS #ffile
  loaf = LOF(ffile)
  CLOSE
  IF loaf = 0 THEN
    CLOSE
    PRINT : PRINT : PRINT
    PRINT "The file, "; filename; " was not found.  Do you want to create it?"
    SELECT CASE YesOrNo
      CASE 1: KILL filename
      newfilename$ = filename
      DO
        filename = Prompt$("Enter EXISTING Z2 file:", "NES", "Zelda2.NES")
        OPEN filename FOR BINARY AS #ffile
        loaf = LOF(ffile): CLOSE
        IF loaf = 0 THEN
          KILL filename
          PRINT : PRINT : PRINT : PRINT "That file doesn't exist."
        ELSE
          SHELL "COPY " + filename + " " + newfilename$ + " /V /B"
          filename = newfilename$
          twemp = 1
        END IF
      LOOP UNTIL twemp = 1
      CASE 0: KILL filename
      GOTO back
    END SELECT
  ELSE
    CLOSE
  END IF
END SUB

SUB MakeCur
DIM tmp AS STRING

tmp = ""
tmp = tmp + "FF3FFF1FFF0FFF07FF03FF01FF007F00"
tmp = tmp + "3F001F00FF01FF10FF307FF87FF87FFC"
tmp = tmp + "00000040006000700078007C007E007F"
tmp = tmp + "807F007C006C00460006000300030000"

FOR x = 0 TO 63
  MID$(cur, x + 1, 1) = CHR$(VAL("&H" + MID$(tmp, x * 2 + 1, 2)))
NEXT

END SUB

FUNCTION Menu (which AS STRING, Prmpt$)
'DIM Items, Item(11) AS STRING, SelItem, Height

OldSel = 0
SelItem = -1

SELECT CASE UCASE$(which)
  CASE "OK"
    Items = 0
    Item(0) = "OK"
    Height = 16
  CASE "YESNO"
    Items = 1
    Item(0) = "No"
    Item(1) = "Yes"
    Height = 16
  CASE "FILE"
    Items = 5
    Item(0) = "Save"
    Item(1) = "Select Map"
    Item(2) = "Revert"
    Item(3) = "Special Loactions"
    Item(4) = "Browse/View dests"
    Item(5) = "Run NESTICLE"
    Height = 16
  CASE "SELECT"
    Items = 3
    Item(0) = "West Hyrule"
    Item(1) = "Death Mountain"
    Item(2) = "East Hyrule"
    Item(3) = "Maze Island"
    Height = 16
END SELECT

dqbboxf 1, 256, 0, 319, 199, 42

Dqbline 1, 319, 0, 319, 199, 38   'Right
Dqbline 1, 256, 199, 319, 199, 36 'Bottom
Dqbline 1, 256, 0, 256, 199, 44   'Left
Dqbline 1, 256, 0, 319, 0, 46     'Top

FOR Itm = 0 TO Items
  y1 = 1 + Itm * Height
  Dqbline 1, 257, y1, 318, y1, 47
  Dqbline 1, 257, y1, 257, y1 + Height - 1, 45
  Dqbline 1, 318, y1, 318, y1 + Height - 1, 35
  Dqbline 1, 257, y1 + Height - 1, 318, y1 + Height - 1, 35
  MenuItemGray Itm
NEXT

x = 0
Y = Height * (Items + 1) + 2

laststop = 1
IF LEN(Prmpt$) > 0 THEN
  DO
    x = x + 1
    IF x >= LEN(Prmpt$) THEN
      x = x + 1
      BlackPrint MID$(Prmpt$, laststop, x - laststop), 257, Y
      EXIT DO
    END IF
    IF MID$(Prmpt$, x, 1) = "|" THEN
      x = x + 1
      BlackPrint MID$(Prmpt$, laststop, x - laststop - 1), 257, Y
      laststop = x
      Y = Y + 6
    END IF
  LOOP
END IF

dqbwait 1
DQBMouseHide
dqbcopylayer 1, 0
dqbMouseShow

DO
  K$ = INKEY$

  FOR Itm = 0 TO Items
    MenuItemGray Itm
  NEXT

  OldSel = SelItem
  SelItem = -1

  IF DQBmouseX < 256 THEN
    IF DQBmouseLB OR DQBmouseRB THEN
      WaitLetGo
      IF DQBmouseX < 256 THEN EXIT DO
    END IF
  END IF
 
  IF K$ = CHR$(27) THEN EXIT DO
 
  IF DQBmouseX >= 257 AND DQBmouseX <= 318 THEN
    IF DQBmouseY >= 1 AND DQBmouseY <= Items * (Height + 1) + 12 THEN
      SelItem = (DQBmouseY - 1) \ 16
      IF DQBmouseLB THEN
        WaitLetGo
        OldSel = SelItem
        SelItem = (DQBmouseY - 1) \ 16
        IF OldSel = SelItem THEN EXIT DO
      END IF
    END IF
  END IF

  IF SelItem > Items THEN SelItem = -1
  IF SelItem >= 0 THEN MenuItemBlue SelItem

  IF OldSel <> SelItem THEN
    dqbwait 1
    DQBMouseHide
    dqbcopylayer 1, 0
    dqbMouseShow
  END IF
 
LOOP
Menu = SelItem

END FUNCTION

SUB MenuItemBlue (Itm)
  y1 = 1 + Itm * Height
  dqbboxf 1, 258, y1 + 1, 317, y1 + Height - 2, 1
  x1 = 288 - DQBlen(Item(Itm)) \ 2
  DQBPrint 1, Item(Itm), x1, y1 + (Height \ 2) - 3, 47
END SUB

SUB MenuItemGray (Itm)
  y1 = 1 + Itm * Height
  dqbboxf 1, 258, y1 + 1, 317, y1 + Height - 2, 43
  x1 = 288 - DQBlen(Item(Itm)) \ 2
  DQBPrint 1, Item(Itm), x1, y1 + (Height \ 2) - 3, 32
END SUB

SUB OverworldEditor

IF DQBmouseDetected > 0 THEN
  dqbboxf 0, 256, 0, 319, 199, 0
  ShadowPrint2 "Mouse Not Found!", 256, 0
  EXIT SUB
END IF

dqbclearlayer 0

'Set the palette
dqbSetPal ovPal

MakeCur
dqbsetmouseshape 0, 0, cur
DQBSetMousePos 160, 100
DQBMouseHide
dqbMouseShow

DrawGui

DispDrawWith

ovSetMap 0
DecompressOverworld
DisplayOverWorld
Cursize = CountMasses

DO
  dqbcopylayer 2, 1

  x1 = (Tx - CameraX) * 16
  y1 = (Ty - CameraY) * 16
  DqbBox 1, x1, y1, x1 + 15, y1 + 15, 15

  x1 = 256 + 14 + (DrawWith \ 8) * 18
  y1 = 7 + (DrawWith AND 7) * 18

  IF DrawWith = 16 THEN
    x1 = 256 + 14
    y1 = 7 + 8 * 18
  END IF

  DqbBox 1, x1, y1, x1 + 17, y1 + 17, 10

  'DispDrawWith
 
  BlackPrint "Y:" + HEX$(Ty + &H1E) + " X:" + HEX$(Tx), 260, 170
  BlackPrint "Size:" + STR$(Cursize) + "/" + STR$(ovmapsize), 258, 176
  BlackPrint "@" + HEX$(AtByte), 295, 170
 
  dqbwait 1
  DQBMouseHide
  dqbcopylayer 1, 0
  dqbMouseShow
 
  DO
    K$ = UCASE$(INKEY$)
  
    ScrollCheck
   
    Tx = CameraX + (DQBmouseX \ 16)
    IF Tx > CameraX + 15 THEN Tx = CameraX + 15
   
    Ty = CameraY + (DQBmouseY \ 16)
    IF Ty > CameraY + 11 THEN Ty = CameraY + 11

    IF OldX <> Tx OR OldY <> Ty THEN EXIT DO
    IF K$ <> "" THEN EXIT DO
    IF DQBmouseLB = true OR DQBmouseRB = true THEN EXIT DO
 
  LOOP
  'Scrolled = 0

  IF OldX <> Tx OR OldY <> Ty THEN DoDraw = False
 
  OldX = Tx
  OldY = Ty

  Actions
 
LOOP UNTIL K$ = CHR$(27)

DQBMouseHide

dqbSetPal pal

END SUB

SUB ovSetMap (Map AS INTEGER)

SELECT CASE Map
  CASE 0: ovOffset = &H506C: ovmapsize = 800
  CASE 1: ovOffset = &H665C: ovmapsize = 802
  CASE 2: ovOffset = 36950: ovmapsize = 793
  CASE 3: ovOffset = 42588: ovmapsize = 802
END SELECT

END SUB

FUNCTION Prompt$ (pmt AS STRING, ext AS STRING, dft AS STRING)

DIM a$

lin = CSRLIN
LOCATE lin, 1

PRINT SPACE$(LEN(pmt) + 16)

PRINT "     (" + CHR$(34) + dft + CHR$(34) + " if no file specified)";
lin = CSRLIN - 1

LOCATE lin, 1

PRINT pmt + "________."; ext;
LOCATE lin, LEN(pmt) + 1, 1, 14, 16

DIM pstring$

fini = 0
DO

DO: a$ = INKEY$: LOOP WHILE a$ = ""

SELECT CASE ASC(a$)
  CASE 27
    LOCATE , LEN(pmt) + 15, 0
    PRINT "Abort program?"
    IF YesOrNo = 1 THEN SYSTEM
    LOCATE lin, LEN(pmt + pstring$) + 1, 1
  CASE 7: BEEP
  CASE 8
    IF LEN(pstring$) > 0 THEN
      pstring$ = LEFT$(pstring$, LEN(pstring$) - 1)
      LOCATE CSRLIN, POS(0) - 1
      PRINT "_";
      LOCATE CSRLIN, POS(0) - 1
  END IF

  CASE 13
    fini = 1

  CASE IS < 33
  CASE ELSE
    IF LEN(pstring$) < 8 THEN
      PRINT a$;
      pstring$ = pstring$ + a$
  END IF

END SELECT

a$ = ""
LOOP UNTIL fini = 1
LOCATE , , 0

FOR twemp = 1 TO LEN(pstring$)
  IF MID$(pstring$, twemp, 1) = "." THEN
    pstring$ = LEFT$(pstring$, twemp - 1)
  END IF
NEXT



Prompt$ = UCASE$(pstring$ + "." + ext)
IF pstring$ = "" THEN Prompt$ = UCASE$(dft)


END FUNCTION

SUB SaveIt

DIM buff AS STRING * 512

DIM tempoff AS LONG
tempoff = 16
OPEN filename FOR BINARY AS #1
  DO
    dqbpeek VARSEG(buff), VARPTR(buff), tempoff, 512
    PUT #1, tempoff + 1, buff
    tempoff = tempoff + 512
    IF tempoff >= 131071 THEN EXIT DO

  LOOP
CLOSE

END SUB

SUB ScrollCheck

OldCameraX = CameraX
OldCameraY = CameraY

IF DQBmouseY = 0 THEN CameraY = CameraY - 1

IF DQBmouseY = 199 THEN CameraY = CameraY + 1

IF DQBmouseX = 0 THEN CameraX = CameraX - 1

IF DQBmouseX = 319 THEN CameraX = CameraX + 1

IF CameraX = OldCameraX AND CameraY = OldCameraY THEN
  Scrolled = False
ELSE
  IF CameraY < 0 THEN CameraY = 0
  IF CameraX < 0 THEN CameraX = 0
  IF CameraY > 75 - 12 THEN CameraY = 75 - 12
  IF CameraX > 64 - 16 THEN CameraX = 64 - 16
  Tx = Tx + CameraX - OldCameraX
  Ty = Ty + CameraY - OldCameraY
  DisplayOverWorld
END IF

END SUB

SUB ShadowPrint2 (text AS STRING, x, Y)

DQBPrint 1, text, x + 1, Y, 1
DQBPrint 1, text, x, Y + 1, 1
DQBPrint 1, text, x + 1, Y + 1, 1
DQBPrint 1, text, x, Y, 15

END SUB

FUNCTION trimstr$ (value)
trimstr$ = LTRIM$(RTRIM$(STR$(value)))
END FUNCTION

SUB WaitLetGo
DO: LOOP WHILE DQBmouseLB OR DQBmouseRB
END SUB

FUNCTION YesOrNo
yn = -1
DO
a$ = INKEY$
SELECT CASE UCASE$(a$)
CASE "Y", "T", "U", "6": yn = 1
CASE "N", "M", "B", " ": yn = 0
END SELECT
LOOP WHILE yn = -1
YesOrNo = yn

END FUNCTION

