DECLARE SUB RenderMap ()
DECLARE SUB Convert ()
DECLARE SUB CopyBack ()
DECLARE SUB renderbackground ()
DECLARE SUB RenderObject (x%, y%, o%)
DEFINT A-Z                'Make new varables integer by default
'$STATIC

'$INCLUDE: 'directqb.bi'  'Include the code provided by DirectQB library
'$INCLUDE: 'z2pledit.bi'  'Include common stuff

CLEAR , , 1999

SUB Convert

DIM oldoffset AS LONG

oldoffset = Offset

DIM bite AS INTEGER
DIM getbyte AS STRING * 1
DIM x AS INTEGER
DIM y AS INTEGER
x1 = 0
ycoord = 0




DQBpeek VARSEG(getbyte), VARPTR(getbyte), Offset, 1
byte1 = ASC(getbyte)
DQBpeek VARSEG(getbyte), VARPTR(getbyte), Offset + 1, 1
byte2 = ASC(getbyte)
DQBpeek VARSEG(getbyte), VARPTR(getbyte), Offset + 2, 1
byte3 = ASC(getbyte)
DQBpeek VARSEG(getbyte), VARPTR(getbyte), Offset + 3, 1
byte4 = ASC(getbyte)

mapsize = 0

Offset = Offset + 4

DO

  DQBpeek VARSEG(getbyte), VARPTR(getbyte), Offset, 1
  bite = ASC(getbyte)
  xspace = bite AND 15: ycoord = bite \ 16
  obj(objno).xs = xspace: obj(objno).yp = ycoord
 
  DQBpeek VARSEG(getbyte), VARPTR(getbyte), Offset + 1, 1
  bite = ASC(getbyte)
  object = bite
  obj(objno).ob = object

  IF object = 15 AND obj(objno).yp < &HD THEN
    Offset = Offset + 1
    DQBpeek VARSEG(getbyte), VARPTR(getbyte), Offset + 1, 1
    obj(objno).ob = 256 + ASC(getbyte)
  END IF

  objno = objno + 1
  mapsize = mapsize + 1
  Offset = Offset + 2

LOOP UNTIL Offset > oldoffset + byte1 - 1
mapsize = mapsize - 1

Offset = oldoffset
END SUB

SUB CopyBack
FOR x = 0 TO 63
FOR y = 0 TO 16
  map(x, y) = back(x, y)
NEXT
NEXT
END SUB

SUB makeback

DIM offset2 AS LONG
DIM bkPointOff AS LONG
offset2 = Offset
byte1b = byte1
byte2b = byte2
byte3b = byte3
Byte4b = byte4

ERASE back

DaBk = Byte4b MOD 8

IF DaBk = 0 THEN EXIT SUB

rombank = DaSet \ 2 + 1
IF DaSet MOD 2 = 0 THEN
  bkPointOff = &H533
ELSE
  bkPointOff = &H2010
END IF

bkPointOff = &HE + DaBk * 2 + 16384 * rombank

Setoff = (rombank - 2) * 16384
Offset = 0
DQBpeek VARSEG(Offset), VARPTR(Offset), bkPointOff, 2
Offset = Offset + Setoff + &H10

Convert

RenderMap

FOR x = 0 TO 63
FOR y = 0 TO 16
  back(x, y) = map(x, y)
NEXT
NEXT

Offset = offset2
'byte1 = byte1b


END SUB

SUB PutMapBack

DIM oldoffset AS LONG

oldoffset = Offset

DIM setbyte AS STRING * 1
x1 = 0
ycoord = 0

setbyte = CHR$(byte1)
DQBpoke VARSEG(setbyte), VARPTR(setbyte), Offset, 1
setbyte = CHR$(byte2)
DQBpoke VARSEG(setbyte), VARPTR(setbyte), Offset + 1, 1
setbyte = CHR$(byte3)
DQBpoke VARSEG(setbyte), VARPTR(setbyte), Offset + 2, 1
setbyte = CHR$(byte4)
DQBpoke VARSEG(setbyte), VARPTR(setbyte), Offset + 3, 1

Offset = Offset + 4

FOR objno = 0 TO numobj
  setbyte = CHR$(obj(objno).xs + obj(objno).yp * 16)
  DQBpoke VARSEG(setbyte), VARPTR(setbyte), Offset, 1
  object = obj(objno).ob
  IF object > 255 THEN
    setbyte = CHR$(15)
    DQBpoke VARSEG(setbyte), VARPTR(setbyte), Offset + 1, 1
    setbyte = CHR$(object - 256)
    DQBpoke VARSEG(setbyte), VARPTR(setbyte), Offset + 2, 1
    Offset = Offset + 3
  ELSE
    setbyte = CHR$(object)
    DQBpoke VARSEG(setbyte), VARPTR(setbyte), Offset + 1, 1
    Offset = Offset + 2
  END IF
NEXT

Offset = oldoffset

END SUB

SUB renderbackground
   
    IF xspace > 64 THEN EXIT SUB
    FOR x = 0 TO xspace - 1
      IF x1 > 63 THEN EXIT SUB
     
      FOR t = 1 TO floor
        map(x1, 12 - t) = 2 + ntset * 4
      NEXT
      IF floor < 12 THEN
        map(x1, 11 - floor) = 1 + ntset * 4
      END IF

      IF noRoof THEN
        FOR t = 2 TO roof
          map(x1, t) = 2 + ntset * 4
        NEXT
        IF roof >= 2 THEN map(x1, roof) = 3 + ntset * 4
      ELSE
        FOR t = 0 TO roof - 1
          map(x1, t) = 2 + ntset * 4
        NEXT
        map(x1, roof) = 3 + ntset * 4
      END IF

      x1 = x1 + 1
    NEXT


END SUB

SUB RenderMap

DIM bite AS INTEGER
DIM getbyte AS STRING * 1
x1 = 0
ycoord = 0

bite = byte3

tset = (bite \ 16) MOD 8
ntset = tset

IF rombank = 3 THEN ntset = tset + 8
IF rombank = 4 OR rombank = 5 THEN ntset = tset + 12

IF (bite AND 15) < 8 THEN
  floor = bite AND 15
  roof = 0
END IF
IF (bite AND 15) > 7 THEN
  roof = (bite AND 15) - 7
  floor = 0
END IF
IF (bite AND 15) = 15 THEN roof = 13: floor = 0
IF (bite AND 128) THEN
  noRoof = -1
ELSE
  noRoof = 0
END IF

ERASE map

CopyBack



FOR x = 0 TO 63
FOR y = 0 TO 16
  Z = map(x, y)
  IF Z < 32 AND 0 = Z MOD 4 THEN map(x, y) = ntset * 4
NEXT
  Z = map(x, 0)
  IF tset = 5 AND Z < 32 AND 0 = Z MOD 4 THEN map(x, 0) = 4
  Z = map(x, 1)
  IF tset = 5 AND Z < 32 AND 0 = Z MOD 4 THEN map(x, 1) = 4
NEXT

x1 = 0
objno = 0

FOR objno = 0 TO mapsize
  xspace = obj(objno).xs: ycoord = obj(objno).yp

  IF xspace > 0 THEN
    IF xspace + x1 > 64 THEN xspace = 64 - x1
    renderbackground
  END IF

  IF x1 > 63 THEN EXIT FOR
  bite = obj(objno).ob
  'object = bite

  SELECT CASE ycoord
    CASE &HE
      map(x1, 0) = 43
      xspace = (obj(objno).xs) * 16 - x1
      renderbackground
    CASE &HD
     IF xspace > 0 OR objno = 0 OR obj(objno - 1).yp = &HE THEN
      IF (bite AND 15) < 8 THEN
        floor = bite AND 15
        roof = 0
      END IF
      IF (bite AND 15) > 7 AND (bite AND 15) < 15 THEN
        roof = (bite AND 15) - 7
        floor = 0
      END IF
      IF (bite AND 15) = 15 THEN
         roof = 13: floor = 0
      END IF
      IF (bite AND 128) THEN
        noRoof = -1
      ELSE
      noRoof = 0
      END IF
     END IF
  END SELECT
NEXT

xspace = 64 - x1
IF xspace > 0 THEN renderbackground

FOR x = 0 TO 63
  IF (byte2 MOD 8) \ 4 THEN map(x, 9) = 109
  IF (byte2 MOD 16) \ 8 THEN map(x, 10) = 110
  SELECT CASE tset
    CASE 1, 6: map(x, 12) = ntset * 4 + 1
    CASE ELSE: map(x, 12) = ntset * 4 + 2
  END SELECT
  IF tset = 2 AND rombank = 5 THEN map(x, 12) = ntset * 4 + 1
NEXT

x1 = 0
objno = 0

FOR objno = 0 TO mapsize
  xspace = obj(objno).xs: ycoord = obj(objno).yp
 
  IF xspace > 0 THEN x1 = x1 + xspace
  
  IF x1 > 64 THEN EXIT FOR
  object = obj(objno).ob

  SELECT CASE ycoord
    CASE &HE
      map(x1, 0) = 79
      xspace = (obj(objno).xs) * 16 - x1
      IF x1 > 0 THEN x1 = x1 + xspace
    CASE &HD
     IF xspace > 0 OR objno = 0 OR obj(objno - 1).yp = &HE THEN
      IF BackInd THEN
        IF (object AND 15) < 8 THEN
          map(x1, 11 - (object AND 7)) = ntset + 60
        END IF
        IF (bite AND 15) > 7 AND (bite AND 15) < 15 THEN
          map(x1, (object AND 7) + 1) = ntset + 60
        END IF
        IF (object AND 15) = 15 THEN
          map(x1, 0) = ntset + 60
        END IF
      END IF
     ELSE
      map(x1, 0) = 56
     END IF
    CASE ELSE
      RenderObject x1, ycoord, object
  END SELECT
NEXT

numobj = mapsize

END SUB

SUB RenderObject (x, y, o)
DIM tx, ty, l
l = o AND 15
SELECT CASE rombank
 CASE 1, 2
  IF y = 15 THEN
    SELECT CASE o                    'Check the object.
      CASE &H0 TO &H1F               'Glitch
        map(x, 12) = cra
      CASE &H20 TO &H2F
        FOR tx = x TO x + l          'Lava
          map(tx, 10) = 9
          map(tx, 11) = 10
          map(tx, 12) = 10
        NEXT
      CASE &H30 TO &H3F
        FOR ty = 9 - l TO 9   'Cactus Stem
          IF ty < 0 THEN EXIT SUB
          map(x, ty) = 115
        NEXT
        map(x, 9 - l) = 114
      CASE &H40 TO &H4F
        map(x, 8) = 112
        map(x, 9) = 113
      CASE &H61 TO &HFF
        map(x, 12) = cra
    END SELECT
    EXIT SUB
  END IF


  SELECT CASE o                    'Check the object
    CASE 0 TO 2: map(x, y) = 80 + o  '0 to 2= Gravestones
    CASE 3                           'Tree Stump
      map(x, y) = 83
      map(x, y + 1) = 84
    CASE 4                           'Stonehenge Formation
      map(x, y + 1) = 85             '(==)
      map(x, y + 2) = 86             '|  |
      map(x + 3, y + 1) = 85
      map(x + 3, y + 2) = 86
      map(x, y) = 87
      map(x + 3, y) = 89
      FOR tx = 1 TO 2
        map(x + tx, y) = 88
        FOR ty = 1 TO 2
          map(x + tx, y + ty) = 4
        NEXT
      NEXT
   'CASE 5                           'Locked Door!
   '  map(x, 8) = 66
   '  map(x, 9) = 67
   '  map(x, 10) = 66
    CASE 6, 7                        'Sleeping Princess Zelda
      map(x, y) = 90
      map(x + 1, y) = 91
    CASE 8                           'Hole
      FOR ty = y TO 12
        map(x, ty) = 4
      NEXT
    CASE 9                           'Full Cloud
      map(x, y) = 93
      map(x + 1, y) = 94
    CASE 10, 11, 12, 13, 14          '3/4 Cloud
      map(x, y) = 93
      map(x + 1, y) = 94
    CASE 15: map(x, y) = cra
   'CASE IS > 255: map(x, y) = 40
  END SELECT

  IF byte2 \ 128 THEN       'Rocky tileset?
  SELECT CASE o             'Check the object.
    CASE &HF TO &H1F          'Crashes Game
      map(x, y) = cra
    CASE &H20 TO &H2F
      FOR tx = x TO x + l     'Rocks
        map(tx, y) = 1
        map(tx, y + 1) = 2
      NEXT
    CASE &H30 TO &H3F
      FOR tx = x TO x + l     'Cave Roof
        map(tx, y) = 2
        map(tx, y + 1) = 3
      NEXT
    CASE &H40 TO &H4F
      FOR tx = x TO x + l     'Bridge
        map(tx, y) = 98
        map(tx, y + 1) = 99
      NEXT
    CASE &H50 TO &H5F
      FOR tx = x TO x + l     'Cave Blocks
        map(tx, y) = 96
      NEXT
    CASE &H60 TO &H6F         'Breakable Blocks
      FOR tx = x TO x + l
        map(tx, y) = 97
      NEXT
    CASE &H70 TO &H7F         'Breaking Bridge
      FOR tx = x TO x + l
        map(tx, y) = 106
      NEXT
    CASE &H80 TO &H8F         'Cattails
      FOR tx = x TO x + l
        map(tx, y) = 107
      NEXT
    CASE &H90 TO &H9F         'Double Cattails
      FOR tx = x TO x + l
        map(tx, y) = 108
      NEXT
    CASE &HA0 TO &HAF         'Pit
      FOR tx = x TO x + l
        map(tx, y) = 4
      NEXT
    CASE &HB0 TO &HBF         'White Blocks
    FOR tx = x TO x + l
      map(tx, y) = 26
    NEXT
  CASE &HC0 TO &HCF           'Volcano Background
    FOR tx = x TO x + l
      map(tx, y) = 20
    NEXT
  CASE &HD0 TO &HDF           'Vertical Breakable Blocks
    FOR ty = y TO y + l
      map(x, ty) = 97
      IF ty > 13 THEN EXIT SUB
    NEXT
  CASE &HE0 TO &HEF           'Vertical Rocks
    map(x, y) = 1
    FOR ty = y + 1 TO y + l
      map(x, ty) = 2
      IF ty > 13 THEN EXIT SUB
    NEXT
  CASE &HF0 TO &HFF           'Stonehenge Pillar
    map(x, y) = 85
    FOR ty = y + 1 TO y + l
      map(x, ty) = 86
      IF ty > 13 THEN EXIT SUB
    NEXT
  END SELECT
  ELSE                       'Foresty tileset
  SELECT CASE o                'Check the object.
    CASE &HF TO &H1F             'Crashes Game
      map(x, y) = cra
    CASE &H20 TO &H2F
      FOR tx = x TO x + l        'Forest Roof
        map(tx, y) = 6
        map(tx, y + 1) = 7
      NEXT
    CASE &H30 TO &H3F
      FOR tx = x TO x + l        'Forest Roof (again)
        map(tx, y) = 6
        map(tx, y + 1) = 7
      NEXT
    CASE &H40 TO &H4F
      FOR tx = x TO x + l        'Curtains
        map(tx, y) = 100
        map(tx, y + 1) = 101
      NEXT
    CASE &H50 TO &H5F
      FOR tx = x TO x + l        'Forest Roof (1 high)
        map(tx, y) = 7
      NEXT
    CASE &H60 TO &H6F            'Breakable Blocks
      FOR tx = x TO x + l
        map(tx, y) = 97
      NEXT
    CASE &H70 TO &H7F            'Nothing
      FOR tx = x TO x + l
        map(tx, y) = 4
      NEXT
    CASE &H80 TO &H8F            'Cattails
      FOR tx = x TO x + l
        map(tx, y) = 107
      NEXT
    CASE &H90 TO &H9F            'Double Cattails
      FOR tx = x TO x + l
        map(tx, y) = 108
      NEXT
    CASE &HA0 TO &HAF            'Staircase
      FOR tx = x TO x + l
        map(tx, y) = 92
      NEXT
    CASE &HB0 TO &HBF            'White Blocks
      FOR tx = x TO x + l
        map(tx, y) = 26
      NEXT
    CASE &HC0 TO &HCF            'Volcano Background
      FOR tx = x TO x + l
        map(tx, y) = 20
      NEXT
    CASE &HD0 TO &HDF            'Vertical Breakable Blocks
      FOR ty = y TO y + l
        map(x, ty) = 97
        IF ty > 13 THEN EXIT SUB
      NEXT
    CASE &HE0 TO &HEF            'Dead Tree
      map(x, y) = 102
      FOR ty = y + 1 TO y + l
        IF ty > 13 THEN EXIT SUB
        map(x, ty) = 103
      NEXT
    CASE &HF0 TO &HFF            'Greek Column
      map(x, y) = 104
      FOR ty = y + 1 TO y + l
        map(x, ty) = 105
        IF ty > 13 THEN EXIT SUB
      NEXT
    END SELECT
  END IF
 CASE 3
 
  '
  '  ***************
  ' **             **
  '**               **
  '*                 *
  '*   Town Tileset  *
  '*     __          *
  '**   | _\        **
  ' **  || ||      **
  '  ***************
  '
  '
  '


  IF y = 15 THEN
    SELECT CASE o                    'Check the object.
      CASE &H0                         'Left Exit
        map(x + 0, 2) = 189
        map(x + 1, 3) = 189
        map(x + 0, 3) = 188
        map(x + 2, 4) = 189
        map(x + 1, 4) = 188
        map(x + 0, 4) = 188
        map(x + 2, 5) = 188
        map(x + 1, 5) = 188
        map(x + 0, 5) = 188
        map(x + 2, 6) = 188
        map(x + 1, 6) = 188
        map(x + 0, 6) = 188
        map(x + 2, 7) = 188
        map(x + 1, 7) = 191
        map(x + 0, 7) = 190
        map(x + 2, 8) = 188
        map(x + 1, 8) = 192
        map(x + 0, 8) = 192
        map(x + 2, 9) = 188
        map(x + 1, 9) = 192
        map(x + 0, 9) = 192
        map(x + 2, 10) = 188
        map(x + 1, 10) = 192
        map(x + 0, 10) = 192
     
      CASE &H1                      'Right Exit
        map(x + 2, 2) = 169
        map(x + 1, 3) = 169
        map(x + 2, 3) = 168
        map(x + 0, 4) = 169
        map(x + 1, 4) = 168
        map(x + 2, 4) = 168
        map(x + 0, 5) = 168
        map(x + 1, 5) = 168
        map(x + 2, 5) = 168
        map(x + 0, 6) = 168
        map(x + 1, 6) = 168
        map(x + 2, 6) = 168
        map(x + 0, 7) = 168
        map(x + 1, 7) = 170
        map(x + 2, 7) = 171
        map(x + 0, 8) = 168
        map(x + 1, 8) = 192
        map(x + 2, 8) = 192
        map(x + 0, 9) = 168
        map(x + 1, 9) = 192
        map(x + 2, 9) = 192
        map(x + 0, 10) = 168
        map(x + 1, 10) = 192
        map(x + 2, 10) = 192

      CASE &H2                      'Left Wall
        map(x + 0, 2) = 189
        map(x + 1, 3) = 189
        map(x + 0, 3) = 188
        map(x + 2, 4) = 189
        map(x + 1, 4) = 188
        map(x + 0, 4) = 188
        FOR ty = 5 TO 10
          FOR tx = x TO x + 2
            map(tx, ty) = 188
            map(tx, 5) = 188
            map(tx, 5) = 188
          NEXT
        NEXT

      CASE &H3                      'Right Wall
        map(x + 2, 2) = 169
        map(x + 1, 3) = 169
        map(x + 2, 3) = 168
        map(x + 0, 4) = 169
        map(x + 1, 4) = 168
        map(x + 2, 4) = 168
        FOR ty = 5 TO 10
          FOR tx = x TO x + 2
            map(tx, ty) = 168
            map(tx, 5) = 168
            map(tx, 5) = 168
          NEXT
        NEXT

      CASE &H5
        map(x, 10) = 174
        map(x + 1, 10) = 175
        map(x + 2, 9) = 172
        map(x + 2, 10) = 173
        map(x + 3, 10) = 175
        map(x + 4, 10) = 176
      CASE &H4
        map(x, 9) = 184
        map(x, 10) = 185
        map(x + 1, 9) = 186
        map(x + 1, 10) = 187
     
      CASE &H6                          'Sign
        map(x, 9) = 195
        map(x, 10) = 196
      CASE &H7                          'King's Tomb
        map(x, 9) = 80
      CASE &H10 TO &H1F                 'Bushes
        map(x, 10) = 158
      CASE &H20 TO &H2F
        FOR y = 4 TO 4 + l
          IF y > 12 THEN EXIT SUB
          map(x, y) = 183
          map(x + 1, y) = 183
          map(x + 2, y) = 4
        NEXT

      CASE &H50
      CASE &H60 TO &H6F              'Bridge and water
        FOR tx = x TO x + l
          map(tx, 10) = 98
          map(tx, 11) = 99
          map(tx, 12) = 9
        NEXT
      CASE &H70 TO &H7F              'Just Water
        FOR tx = x TO x + l
          map(tx, 11) = 4
          map(tx, 12) = 9
        NEXT
      CASE ELSE
        map(x, 12) = cra
    END SELECT
    EXIT SUB
  END IF

  SELECT CASE o                    'Check the object
    CASE 0: map(x, y + 0) = 116        'Door 1
            map(x, y + 1) = 117
            map(x, y + 2) = 118
            map(x, y + 3) = 41
    CASE 1: map(x, y + 0) = 120        'Door 2
            map(x, y + 1) = 121
            map(x, y + 2) = 121
            map(x, y + 3) = 41
    CASE 2: map(x, y + 0) = 120        'Door 2
            map(x, y + 1) = 121
            map(x, y + 2) = 121
            map(x, y + 3) = 38
    CASE 3: map(x, y + 0) = 120        'Door 2
            map(x, y + 1) = 121
            map(x, y + 2) = 121
            map(x, y + 3) = 119
    CASE 4                           'Stonehenge Formation
      map(x, y + 1) = 85             '(==)
      map(x, y + 2) = 86             '|  |
      map(x + 3, y + 1) = 85
      map(x + 3, y + 2) = 86
      map(x, y) = 87
      map(x + 3, y) = 89
      FOR tx = 1 TO 2
        map(x + tx, y) = 88
        FOR ty = 1 TO 2
          map(x + tx, y + ty) = 4
        NEXT
      NEXT
    CASE 5: map(x, y) = 179          'Chair

    CASE 7                           'Full Cloud
      map(x, y) = 93
      map(x + 1, y) = 94
    CASE 9                           'Bench
      map(x, y) = 177
      map(x + 1, y) = 177
      map(x + 2, y) = 197
      map(x + 3, y) = 178
      map(x + 4, y) = 178

    CASE &HA
      map(x, y) = 81                 'Grave Cross
    CASE 8                           'Table
      map(x, y) = 180
      map(x, y + 1) = 181
      map(x + 1, y) = 180
      map(x + 1, y + 1) = 182
    CASE 9, 11, 12, 13, 14           '3/4 Cloud
      map(x, y) = 93
      map(x + 1, y) = 94
    CASE 15: map(x, y) = cra
   'CASE IS > 255: map(x, y) = 40
  END SELECT

  IF byte2 \ 128 = 0 THEN     'Foresty Tileset:
  SELECT CASE o                'Check the object.
    CASE &HF TO &H1F             'Crashes Game
      map(x, y) = cra
    CASE &H20 TO &H2F
      FOR tx = x TO x + l        'Brown Roof
        map(tx, y) = 146
        map(tx, y + 1) = 147
      NEXT
    CASE &H30 TO &H3F
      FOR tx = x TO x + l        'Roof
        map(tx, y) = 148
        map(tx, y + 1) = 149
      NEXT
    CASE &H40 TO &H4F
      FOR tx = x TO x + l        'Roof
        map(tx, y) = 150
        map(tx, y + 1) = 151
      NEXT
    CASE &H50 TO &H5F
      FOR tx = x TO x + l - 1    'Brown Bricks
        FOR ty = y TO 10
          map(tx, ty) = 163
        NEXT
      NEXT
      FOR ty = y TO 10
        map(tx, ty) = 162
      NEXT
   
    CASE &H60 TO &H6F
      FOR tx = x TO x + l - 1    'White Bricks
        FOR ty = y TO 10
          map(tx, ty) = 165
        NEXT
      NEXT
      FOR ty = y TO 10
        map(tx, ty) = 164
      NEXT
    CASE &H70 TO &H7F
      FOR tx = x TO x + l - 1    'Mess Wall
        FOR ty = y TO 10
          map(tx, ty) = 161
        NEXT
      NEXT
      FOR ty = y TO 10
        map(tx, ty) = 160
      NEXT
    CASE &H80 TO &H8F            'Room Bricks
      FOR tx = x TO x + l
        FOR ty = y TO 10
          map(tx, ty) = 38
        NEXT
      NEXT
    CASE &H90 TO &H9F
      FOR tx = x TO x + l - 1    'Log Wall
        FOR ty = y TO 10
          map(tx, ty) = 167
        NEXT
      NEXT
      FOR ty = y TO 10
        map(tx, ty) = 166
      NEXT
    CASE &HA0 TO &HAF            'Square Windows
      FOR ty = y TO y + l * 3 STEP 3
        IF ty > 12 THEN EXIT SUB
        map(x, ty) = 152
        map(x, ty + 1) = 152
      NEXT
    CASE &HB0 TO &HBF            'White Windows
      FOR ty = y TO y + l * 3 STEP 3
        IF ty > 12 THEN EXIT SUB
        map(x, ty) = 156
        map(x, ty + 1) = 157
      NEXT
    CASE &HC0 TO &HCF            'Brown Windows
      FOR ty = y TO y + l * 3 STEP 3
        IF ty > 12 THEN EXIT SUB
        map(x, ty) = 154
        map(x, ty + 1) = 155
      NEXT
    CASE &HD0 TO &HDF            'Basement Blocks
      FOR tx = x TO x + l
        map(tx, y) = 33
        map(tx, y + 1) = 33
      NEXT
    CASE &HE0 TO &HEF            'Column
      map(x, y) = 104
      FOR ty = y + 1 TO y + l
        IF ty > 13 THEN EXIT SUB
        map(x, ty) = 105
      NEXT
    CASE &HF0 TO &HFF            'White Blocks
      FOR tx = x TO x + l
        map(tx, y) = 26
      NEXT
    END SELECT
  ELSE
  SELECT CASE o             'Check the object.
    CASE &HF TO &H1F          'Crashes Game
      map(x, y) = cra
    CASE &H20 TO &H2F
      FOR tx = x TO x + l     'Rocks
        map(tx, y) = 1
        map(tx, y + 1) = 2
      NEXT
    CASE &H30 TO &H3F
      FOR tx = x TO x + l     'Cave Roof
        map(tx, y) = 2
        map(tx, y + 1) = 3
      NEXT
    CASE &H40 TO &H4F
      FOR tx = x TO x + l     'Bridge
        map(tx, y) = 98
        map(tx, y + 1) = 99
      NEXT
    CASE &H50 TO &H5F
      FOR tx = x TO x + l     'Cave Blocks
        map(tx, y) = 96
      NEXT
    CASE &H60 TO &H6F         'Breakable Blocks
      FOR tx = x TO x + l
        map(tx, y) = 97
      NEXT
    CASE &H70 TO &H7F         'Breaking Bridge
      FOR tx = x TO x + l
        map(tx, y) = 106
      NEXT
    CASE &H80 TO &H8F         'Cattails
      FOR tx = x TO x + l
        map(tx, y) = 107
      NEXT
    CASE &H90 TO &H9F         'Double Cattails
      FOR tx = x TO x + l
        map(tx, y) = 108
      NEXT
    CASE &HA0 TO &HAF         'Pit
      FOR tx = x TO x + l
        map(tx, y) = 4
      NEXT
    CASE &HB0 TO &HBF         'White Blocks
    FOR tx = x TO x + l
      map(tx, y) = 26
    NEXT
  CASE &HC0 TO &HCF           'Volcano Background
    FOR tx = x TO x + l
      map(tx, y) = 20
    NEXT
  CASE &HD0 TO &HDF           'Vertical Breakable Blocks
    FOR ty = y TO y + l
      map(x, ty) = 97
      IF ty > 13 THEN EXIT SUB
    NEXT
  CASE &HE0 TO &HEF           'Vertical Rocks
    map(x, y) = 1
    FOR ty = y + 1 TO y + l
      map(x, ty) = 2
      IF ty > 13 THEN EXIT SUB
    NEXT
  CASE &HF0 TO &HFF           'Stonehenge Pillar
    map(x, y) = 85
    FOR ty = y + 1 TO y + l
      map(x, ty) = 86
      IF ty > 13 THEN EXIT SUB
    NEXT
  END SELECT
  END IF

 CASE 4
  '   *******************
  '  **                 **
  ' **      PALACE       **
  '**                     **
  ' **     TILESET!      **
  '  **                 **
  '   *******************
  '

  IF y = 15 THEN
    SELECT CASE o                    'Check the object.
      CASE &H0 TO &HF                'Glitch
        map(x, 12) = cra
      CASE &H10 TO &H1F
        FOR tx = x TO x + l          'Short Lava
          map(tx, 11) = 9
          map(tx, 12) = 10
        NEXT
      CASE &H50
      CASE ELSE
        map(x, 12) = cra
    END SELECT
    EXIT SUB
  END IF


  SELECT CASE o                    'Check the object
    CASE 0: map(x, y) = 124          '0=Window
            map(x, y + 1) = 125
    CASE 1 TO 2: map(x, y) = 125 + o '1=Unicorn Head
                 map(x, y + 1) = 48  '2=Wolf's Head
    CASE 3, 4                        'Crystal Altar
      map(x + 0, y + 0) = 48
      map(x + 0, y + 1) = 48
      map(x + 0, y + 2) = 48
      map(x + 0, y + 3) = 128
      map(x + 0, y + 4) = 129
      map(x + 1, y + 0) = 130
      map(x + 1, y + 1) = 131
      map(x + 1, y + 2) = 132
      map(x + 1, y + 3) = 133
      map(x + 1, y + 4) = 134
      map(x + 2, y + 0) = 135
      map(x + 2, y + 1) = 136
      map(x + 2, y + 2) = 137
      map(x + 2, y + 3) = 138
      map(x + 2, y + 4) = 139
      map(x + 3, y + 0) = 48
      map(x + 3, y + 1) = 48
      map(x + 3, y + 2) = 48
      map(x + 3, y + 3) = 128
      map(x + 3, y + 4) = 129

   'CASE 5,6                        'Locked Door!
   '  map(x, 8) = 66
   '  map(x, 9) = 67
   '  map(x, 10) = 66
    CASE 7                          'Full Cloud
      map(x, y) = 93
      map(x + 1, y) = 94
    CASE 8, 10, 11, 12, 13, 14      '3/4 Cloud
      map(x, y) = 93
      map(x + 1, y) = 95
    CASE 9                           'Ironknuckle Statue
      map(x, y) = 122
      map(x, y + 1) = 123
    CASE 15: map(x, y) = cra
  END SELECT

  SELECT CASE o                'Check the object.
    CASE &H10 TO &H1F
      FOR tx = x TO x + l        'Horizontal Nothing
        map(tx, y) = 4
      NEXT
    CASE &H20 TO &H2F
      FOR tx = x TO x + l        'Single Horizontal Blocks
        map(tx, y) = 49
      NEXT
    CASE &H30 TO &H3F
      FOR tx = x TO x + l        'Breakable Blocks
        map(tx, y) = 97
      NEXT
    CASE &H40 TO &H4F
      FOR tx = x TO x + l        'Curtains
        map(tx, y) = 140
      NEXT
    CASE &H50 TO &H5F
      FOR tx = x TO x + l        'Breaking Bridge
        map(tx, y) = 106
      NEXT
    CASE &H60 TO &H6F            'Breakable Blocks
      FOR tx = x TO x + l
        map(tx, y) = 97
      NEXT
    CASE &H70 TO &H7F            'Horizontal Stone 2
      FOR tx = x TO x + l
        map(tx, y) = 49
        map(tx, y + 1) = 49
      NEXT
    CASE &H80 TO &H8F
      FOR tx = x TO x + l        'Curtains
        map(tx, y) = 100
        map(tx, y + 1) = 101
      NEXT
    CASE &H90 TO &H9F            'Double Breakable Blocks
      FOR tx = x TO x + l
        map(tx, y) = 97
        map(tx, y + 1) = 97
      NEXT
    CASE &HA0 TO &HAF            'Fake Wall
      FOR tx = x TO x + l
        map(tx, y) = 143
        map(tx, y + 1) = 143
      NEXT
    CASE &HB0 TO &HBF            'Vertical Breakable Blocks
    FOR ty = y TO y + l
      IF ty > 13 THEN EXIT SUB
      map(x, ty) = 97
    NEXT
    CASE &HC0 TO &HCF            'Greek Column
      map(x, y) = 141
      FOR ty = y + 1 TO y + l
        map(x, ty) = 142
        IF ty > 13 THEN EXIT SUB
      NEXT
    CASE &HD0 TO &HDF            'Bridge
      FOR tx = x TO x + l
        map(tx, y) = 144
        map(tx, y + 1) = 145
      NEXT
    CASE &HE0 TO &HEF            'Vertical Nothing
      FOR ty = y TO y + l
        IF ty > 13 THEN EXIT SUB
        map(x, ty) = 4
      NEXT
    CASE &HF0 TO &HFF            'Horizontal Hole
      FOR tx = x TO x + l
        FOR ty = y TO 12
          map(tx, ty) = 4
        NEXT
      NEXT
    END SELECT
 CASE 5
  '   ==================
  '                |\|
  '         GREAT  \|\
  '                |\|
  '        PALACE! \|\
  '    **          |\|
  '   ==================
  '

  IF y = 15 THEN
    SELECT CASE o                    'Check the object.
      CASE &H0 TO &HF                'Glitch
        map(x, 12) = cra
      CASE &H10 TO &H1F
        FOR tx = x TO x + l          'Short Lava
          map(tx, 11) = 9
          map(tx, 12) = 10
        NEXT
      CASE &H50
      CASE ELSE
        map(x, 12) = cra
    END SELECT
    EXIT SUB
  END IF


  SELECT CASE o                    'Check the object
    CASE 0: map(x, y) = 124          '0=Window
            map(x, y + 1) = 125
    CASE 1: map(x, y) = 125 + o    'Unicorn Head
            map(x, y + 1) = 48     '
    CASE 2, 3, 4                   'Wolf's Head
      map(x, y) = 127
      map(x, y + 1) = 48

    'CASE 5                         'Locked Door
    CASE 6                          'Elevator Hole
      FOR ty = y TO 12
        map(x, ty) = 4
      NEXT
    CASE 7                          'Full Cloud
      map(x, y) = 93
      map(x + 1, y) = 94
    CASE 9                          'Sleeping Princess Zelda
      map(x, y) = 198
      map(x + 1, y) = 199
    CASE 8, 11, 12, 13, 14          '3/4 Cloud
      map(x, y) = 93
      map(x + 1, y) = 95
    CASE &HA                        'Ironknuckle Statue
      map(x, y) = 122
      map(x, y + 1) = 123
    CASE 15: map(x, y) = cra
  END SELECT

  SELECT CASE o                'Check the object.
    CASE &H10 TO &H1F
      FOR tx = x TO x + l        'Horizontal Nothing
        map(tx, y) = 200
      NEXT
    CASE &H20 TO &H2F
      FOR tx = x TO x + l        'Single Horizontal Blocks
        map(tx, y) = 49
      NEXT
    CASE &H30 TO &H3F
      FOR tx = x TO x + l        'Breakable Blocks
        map(tx, y) = 97
      NEXT
    CASE &H40 TO &H4F
      FOR tx = x TO x + l        'Steel Blocks
        map(tx, y) = 140
      NEXT
    CASE &H50 TO &H5F            'White Blocks
    FOR tx = x TO x + l
      map(tx, y) = 58
    NEXT
    CASE &H60 TO &H6F            'Stairs
      FOR tx = x TO x + l
        map(tx, y) = 193
      NEXT
    CASE &H70 TO &H7F
      FOR tx = x TO x + l        'Breaking Bridge
        map(tx, y) = 106
      NEXT
    CASE &H80 TO &H8F
      FOR tx = x TO x + l        'Bridge
        map(tx, y) = 144
        map(tx, y + 1) = 145
      NEXT
    CASE &H90 TO &H9F            'Double Blocks
      FOR tx = x TO x + l
        map(tx, y) = 49
        map(tx, y + 1) = 49
      NEXT
    CASE &HA0 TO &HAF            'Curtians
      FOR tx = x TO x + l
        map(tx, y) = 100
        map(tx, y + 1) = 101
      NEXT
    CASE &HB0 TO &HBF            'Fake Wall
      FOR tx = x TO x + l
        map(tx, y) = 143
        map(tx, y + 1) = 143
      NEXT
    CASE &HC0 TO &HCF            'Double Breakable Blocks
      FOR tx = x TO x + l
        map(tx, y) = 97
        map(tx, y + 1) = 97
      NEXT
    CASE &HD0 TO &HDF            'Vertical Breakable Blocks
      FOR ty = y TO y + l
        map(x, ty) = 97
        IF ty > 13 THEN EXIT SUB
      NEXT
    CASE &HE0 TO &HEF            'Vertical Nothing
      FOR ty = y TO y + l
        IF ty > 13 THEN EXIT SUB
        map(x, ty) = 194
      NEXT
    CASE &HF0 TO &HFF            'Vertical Column
      map(x, y) = 141
      FOR ty = y + 1 TO y + l
        map(x, ty) = 142
        IF ty > 13 THEN EXIT SUB
      NEXT
    END SELECT

END SELECT

END SUB

