DECLARE SUB setpal (pl AS INTEGER)
DECLARE SUB RenderMap ()
DECLARE SUB DrawMap (xoff AS INTEGER, startx%, endx%, pxloff%)
DECLARE SUB ShadowPrint (Text$, x%, y%)
DECLARE SUB DispKeys (set AS STRING)
DEFINT A-Z
'$STATIC

'$INCLUDE: 'directqb.bi'  'Include the code provided by DirectQB library
'$INCLUDE: 'z2pledit.bi'  'Include common stuff

SUB FlagsEdit

DIM BIT(7)

DispKeys "flags"

FOR x = 0 TO 7
IF (byte2 \ 2 ^ x) AND 1 THEN BIT(x) = TRUE
NEXT

oldbyte2 = byte2

DO
  byte2 = 0
  FOR x = 0 TO 7
    IF BIT(x) THEN byte2 = byte2 + 2 ^ x
  NEXT
  RenderMap
  DrawMap xd, 0, 15, 0

  DQBboxf 0, 256, 70, 319, 199, 0
  ShadowPrint "Tileset=", 256, 96
  IF BIT(7) THEN
    ShadowPrint "Rocky", 284, 96
  ELSE
    ShadowPrint "Foresty", 284, 96
  END IF
  wid = 0
  IF BIT(6) THEN wid = 2
  IF BIT(5) THEN wid = wid + 1
  ShadowPrint "Pages=" + LTRIM$(STR$(wid + 1)), 256, 104
  ShadowPrint "Bushes=", 256, 112
  IF BIT(3) THEN
    ShadowPrint "Yes", 284, 112
  ELSE
    ShadowPrint "No", 284, 112
  END IF
  ShadowPrint "Grass=", 256, 120
  IF BIT(2) THEN
    ShadowPrint "Yes", 284, 120
  ELSE
    ShadowPrint "No", 284, 120
  END IF
  FOR x = 0 TO 7
    IF BIT(x) THEN
      ShadowPrint "1", 300 - 4 * x, 128
    ELSE
      ShadowPrint "0", 300 - 4 * x, 128
    END IF
  NEXT
 
  a$ = ""
  WHILE a$ = ""
    a$ = INKEY$
  WEND

  SELECT CASE UCASE$(a$)
    CASE "B"
      BIT(3) = NOT BIT(3)
  
    CASE "G"
      BIT(2) = NOT BIT(2)


    CASE CHR$(0) + "K"
      wid = 0
      IF BIT(6) THEN wid = 2
      IF BIT(5) THEN wid = wid + 1
      wid = wid - 1
      SELECT CASE wid
        CASE 2: BIT(6) = TRUE: BIT(5) = FALSE
        CASE 1: BIT(6) = FALSE: BIT(5) = TRUE
        CASE IS < 1: BIT(6) = FALSE: BIT(5) = FALSE
      END SELECT
    CASE CHR$(0) + "M"
      wid = 0
      IF BIT(6) THEN wid = 2
      IF BIT(5) THEN wid = wid + 1
      wid = wid + 1
      SELECT CASE wid
        CASE IS > 2: BIT(6) = TRUE: BIT(5) = TRUE
        CASE 2: BIT(6) = TRUE: BIT(5) = FALSE
        CASE 1: BIT(6) = FALSE: BIT(5) = TRUE
      END SELECT
    CASE "T": BIT(7) = NOT BIT(7)

    CASE CHR$(27)
      byte2 = oldbyte2
      RenderMap
      DrawMap xd, 0, 15, 0
      EXIT SUB

    CASE CHR$(13)
      EXIT DO
    CASE "0" TO "7"
      BIT(VAL(a$)) = NOT BIT(VAL(a$))

  END SELECT

LOOP

  byte2 = 0
  FOR x = 0 TO 7
    IF BIT(x) THEN byte2 = byte2 + 2 ^ x
  NEXT
LvMod = -1

END SUB

SUB PalEdit
COLOR 7

DIM pl, bk, br, cr

DQBboxf 0, 256, 0, 319, 199, 0

DispKeys "pal"

bk = byte4 MOD 8
pl = (byte4 \ 8) MOD 8
IF byte4 \ 64 MOD 2 THEN br = -1
IF byte4 \ 128 THEN cr = -1

oldbyte4 = byte4

setpal pl
DO
  DQBboxf 0, 256, 70, 319, 199, 0
  ShadowPrint "Palette:", 256, 96

  SELECT CASE pl
    CASE 0: name$ = "North Castle"
    CASE 1: name$ = "Cave Palette"
    CASE 2: name$ = "Desert Palette"
    CASE 3: name$ = "Grass Palette"
    CASE 4: name$ = "Forest Palette"
    CASE 5: name$ = "Swamp Palette"
    CASE 6: name$ = "Graveyard Palette"
    CASE 7: name$ = "Water Palette"
  END SELECT

  ShadowPrint HEX$(pl) + ":" + name$, 256, 102
  'ShadowPrint "Backgrnd=" + HEX$(bk), 256, 110
  ShadowPrint "Bright:", 256, 118
  IF br THEN
    ShadowPrint "ON", 280, 118
  ELSE
    ShadowPrint "OFF", 280, 118
  END IF
  ShadowPrint "Crazy:", 256, 126
  IF cr THEN
    ShadowPrint "ON", 280, 126
  ELSE
    ShadowPrint "OFF", 280, 126
  END IF

  a$ = ""
  WHILE a$ = ""
    a$ = INKEY$
  WEND

  SELECT CASE UCASE$(a$)
    CASE CHR$(0) + "P"
      pl = pl - 1
      IF pl < 0 THEN pl = 7
 
    CASE CHR$(0) + "H"
      pl = pl + 1
      IF pl > 7 THEN pl = 0
 
    CASE "B"
      br = NOT br
   
    CASE "C"
      cr = NOT cr
 
    CASE CHR$(27)
      pl = (byte4 \ 8) MOD 8
      byte4 = oldbyte4
      setpal pl
      EXIT SUB
 
    CASE CHR$(13)
      EXIT DO

  END SELECT

byte4 = pl * 8 + bk
IF br THEN byte4 = byte4 + 64
IF cr THEN byte4 = byte4 + 128
setpal pl

LOOP
LvMod = -1

END SUB

SUB TsetEdit
COLOR 7

DIM ts, bk, rf

DispKeys "tset"

ts = (byte3 \ 16) MOD 8
bk = byte3 AND 15
IF byte3 \ 128 THEN rf = TRUE

oldbyte3 = byte3

DO
  byte3 = ts * 16 + bk
  IF rf THEN byte3 = byte3 + 128
  RenderMap
  DrawMap xd, 0, 15, 0

  DQBboxf 0, 256, 70, 319, 199, 0
  ShadowPrint "Tileset:", 256, 96

  SELECT CASE ts
    CASE 0: name$ = "Cave Tileset"
    CASE 1: name$ = "Forest Tilset"
    CASE 2: name$ = "Lava/Death water"
    CASE 3: name$ = "Swamp Tileset"
    CASE 4: name$ = "Sand/Grass"
    CASE 5: name$ = "Volcano Tileset"
    CASE 6: name$ = "Castle/Ruins"
    CASE 7: name$ = "Rocks Outside"
  END SELECT

  ShadowPrint HEX$(ts) + ":" + name$, 256, 102

  ShadowPrint "Blocks:", 256, 110

  SELECT CASE bk
    CASE 0 TO 7: name$ = "Floor at " + HEX$(bk + 2)
    CASE 8 TO 14: name$ = "Roof at " + HEX$(bk - 6)
    CASE 15: name$ = "Filled in"
  END SELECT

  ShadowPrint HEX$(bk) + ":" + name$, 256, 116

  ShadowPrint "NoRoof:", 256, 124
  IF rf THEN
    ShadowPrint "ON", 283, 124
  ELSE
    ShadowPrint "OFF", 283, 124
  END IF
 
  a$ = ""
  WHILE a$ = ""
    a$ = INKEY$
  WEND

  SELECT CASE UCASE$(a$)
    CASE CHR$(0) + "H"
      ts = ts - 1
      IF ts < 0 THEN ts = 7

    CASE CHR$(0) + "P"
      ts = ts + 1
      IF ts > 7 THEN ts = 0

    CASE CHR$(0) + "K"
      bk = bk - 1
      IF bk < 0 THEN bk = 15

    CASE CHR$(0) + "M"
      bk = bk + 1
      IF bk > 15 THEN bk = 0

    CASE "R": rf = NOT rf

    CASE CHR$(27)
      byte3 = oldbyte3
      RenderMap
      DrawMap xd, 0, 15, 0
      EXIT SUB

    CASE CHR$(13)
      EXIT DO

  END SELECT

LOOP

LvMod = TRUE

END SUB

