'$STATIC

'Constant for highest map number
CONST firsttil = 84
CONST TownBack = 32
CONST PalaceBack = 52
CONST cra = 78
CONST ski = 79

CONST maxmap = 150

'Array type contains 3 elements:
' Xspace: amount of space before the object
' Yposition: The vertical position of the object
' Object: The type of object
TYPE objtype
  xs AS INTEGER
  yp AS INTEGER
  ob AS INTEGER
END TYPE


'====================
'Varable Declaration:
'====================
'$STATIC

'The array for objects
DIM SHARED obj(-1 TO 127) AS objtype

'The array for enemies
DIM SHARED nme(-1 TO 127) AS objtype

'The Tile matrix
DIM SHARED map(-1 TO 80, 16) AS INTEGER
DIM SHARED back(0 TO 63, 16) AS INTEGER

'Buffer for graphics
DIM SHARED tilebuf(129) AS INTEGER

'Offsets
COMMON SHARED PointOff AS LONG, Setoff AS LONG, nmePointOff AS LONG, nmeSetOff AS LONG

'Name of the file being used
COMMON SHARED filename AS STRING

'Map parameters and data from rom
COMMON SHARED byte1, byte2, byte3, byte4, mapsize, tset, ntset, numobj, nmelen
COMMON SHARED numnme

'Coordinates used by editor
COMMON SHARED xspace, ycoord, x1
COMMON SHARED oxd, xd, ooff, mapno, noff, nmeMapNo

'The array for objects
COMMON SHARED obj() AS objtype

'The array for enemies :)
COMMON SHARED nme() AS objtype

'Data to hold palette data
COMMON SHARED palstring AS STRING

'The actual palette
COMMON SHARED Pal AS STRING * 768

'lame sound
COMMON SHARED chirp$

'The Tile matrix
COMMON SHARED map() AS INTEGER
COMMON SHARED back() AS INTEGER

'Buffer for graphics
COMMON SHARED tilebuf() AS INTEGER

'The offset of the map data
COMMON SHARED Offset AS LONG, nmeOffset AS LONG

'Bits used in generation of maps
COMMON SHARED roof, floor, noRoof

'Frontend crap
COMMON SHARED TheMap AS INTEGER
COMMON SHARED rombank AS SINGLE
COMMON SHARED DaSet AS INTEGER
COMMON SHARED DaMap AS INTEGER
COMMON SHARED NewMapOff AS LONG

'Flags
COMMON SHARED BackEdit, NoCandle, StrongEnemy, ScrollMode, LvMod, EnMod, verbose
COMMON SHARED BackInd

