DECLARE FUNCTION hex2$ (param AS LONG)
DECLARE SUB ShadowPrint (Text$, x%, y%)
DECLARE FUNCTION GetX2% (objno AS INTEGER)
DECLARE SUB BlitNme (x%, y%, pxloff%, Z%)
DECLARE SUB ScrollMapLeft (xoff AS INTEGER, xdest AS INTEGER, ScrollSpeed%)
DECLARE SUB ScrollMapRight (xoff AS INTEGER, xdest AS INTEGER, ScrollSpeed%)
DECLARE SUB DrawMap (xoff AS INTEGER, startx%, endx%, pxloff%)
DECLARE SUB DrawTile (x%, y%, pxloff%, Z%)
DECLARE SUB DrawNme (xoff AS INTEGER, pxloff AS INTEGER)
'$INCLUDE: 'directqb.bi'
'$INCLUDE: 'z2pledit.bi'

SUB BlitNme (x, y, pxloff, Z)

x1 = (Z \ 11) * 16: y1 = (Z MOD 11) * 16

DQBget 3, x1, y1, x1 + 15, y1 + 15, VARSEG(tilebuf(0)), VARPTR(tilebuf(0))
DQBput 1, x * 16 + pxloff, y * 16, VARSEG(tilebuf(0)), VARPTR(tilebuf(0))

END SUB

SUB DispKeys (set AS STRING)

DQBboxf 0, 256, 0, 319, 100, 0

SELECT CASE LCASE$(set)
  CASE "flags"
    ShadowPrint "Flags", 256, 0
    ShadowPrint "Editor:", 256, 6

    ShadowPrint "0-7: Toggle Bits", 256, 16

    ShadowPrint CHR$(27) + CHR$(26) + ":Level Length", 256, 24
    ShadowPrint "T:Toggle Tileset", 256, 32
    ShadowPrint "B:Toggle Bushes", 256, 40
    ShadowPrint "G:Toggle Grass", 256, 48

    ShadowPrint "Enter:OK", 256, 58
    ShadowPrint "Esc:Cancel", 256, 66
  CASE "tset"
    ShadowPrint "Tileset/Blocks", 256, 0
    ShadowPrint "Editor:", 256, 6

    ShadowPrint ":Change Tileset", 256, 18

    ShadowPrint CHR$(27) + CHR$(26) + ":Change Blocks", 256, 26
    ShadowPrint "R:Toggle Roof", 256, 34

    ShadowPrint "Enter:OK", 256, 54
    ShadowPrint "Esc:Cancel", 256, 62
  CASE "pal"
    ShadowPrint "Palette", 256, 0
    ShadowPrint "Editor:", 256, 6

    ShadowPrint ":Change Palette", 256, 18
    ShadowPrint "B:Toggle Bright", 256, 32
    ShadowPrint "Sprites", 262, 40
    ShadowPrint "C:Toggle Crazy", 256, 48
    ShadowPrint "Sprites", 262, 54
    ShadowPrint "Enter:OK", 256, 62
    ShadowPrint "Esc:Cancel", 256, 70
  CASE "back"
    ShadowPrint "Backgrnd", 256, 0
    ShadowPrint "Editor:", 256, 6
    ShadowPrint CHR$(27) + CHR$(26) + ":Change Backgrnd", 256, 18
    ShadowPrint "E:Edit map", 256, 26

    ShadowPrint "Enter:OK", 256, 62
    ShadowPrint "Esc:Cancel", 256, 70
  CASE "main"
    ShadowPrint "Keys:", 256, 0
    ShadowPrint "ESC:Exit, no save", 256, 8
    ShadowPrint "S:Save level", 256, 14
    ShadowPrint "Page up/dn:Change lv", 256, 20
    ShadowPrint "<,>:Scroll L/R", 256, 26
    ShadowPrint CHR$(27) + CHR$(26) + ":Select Object", 256, 34
    ShadowPrint "-,+:Dec/Inc Obj", 256, 40
    ShadowPrint "/,*:Dec/Inc 16", 256, 46
    ShadowPrint "[,]:Spacing", 256, 52
    ShadowPrint "F:Edit Flags", 256, 60
    ShadowPrint "T:Edit Tileset", 256, 66
    ShadowPrint "P:Edit Palette", 256, 72
    ShadowPrint "B:Edit Background", 256, 78
    ShadowPrint "I:Integrity Check", 256, 86
  CASE "nme"
    ShadowPrint "Keys:", 256, 0
    ShadowPrint "ESC: Back", 256, 8
    ShadowPrint "S:Save Enemies", 256, 14
    ShadowPrint "Page up/dn:Change Mp", 256, 20
    ShadowPrint "<,>:Scroll L/R", 256, 26
    ShadowPrint CHR$(27) + CHR$(26) + ":Select Enemy", 256, 34
    ShadowPrint "-,+:Dec/Inc Obj", 256, 40
    ShadowPrint "/,*:Dec/Inc 16", 256, 46
  CASE "view"
    ShadowPrint "Keys:", 256, 0
    ShadowPrint "ESC:Return", 256, 8
    ShadowPrint CHR$(27) + CHR$(26) + ":Scroll Map", 256, 16
  CASE "choose"
    ShadowPrint "Keys:", 256, 0
    ShadowPrint "ESC:Exit", 256, 7
    ShadowPrint CHR$(27) + CHR$(26) + ":Scroll L/R", 256, 14
    ShadowPrint "Page Up,Page Down:", 256, 21
    ShadowPrint "Change Map", 264, 27
    ShadowPrint "E: Edit Level", 256, 34
    ShadowPrint "M: Edit Monsters", 256, 41
    ShadowPrint "W: Toggle Weak/", 256, 48
    ShadowPrint "        Strong enemy", 256, 54
    ShadowPrint "N: Run Nesticle", 256, 61
    ShadowPrint "O: Edit Overworld", 256, 68
    ShadowPrint "P: Editor Prefs", 256, 75
    ShadowPrint "J: Jump to map#x", 256, 82
END SELECT
END SUB

SUB DispStats (set AS STRING)

DQBboxf 0, 256, 101, 319, 199, 0

SELECT CASE LCASE$(set)
  CASE "main"
    ShadowPrint "Object Num:" + LTRIM$(STR$(ooff)) + "/" + LTRIM$(STR$(numobj)), 256, 101
    ShadowPrint "Xspace=" + HEX$(obj(ooff).xs), 260, 109
    ShadowPrint "Ypos=" + HEX$(obj(ooff).yp), 265, 117
    ShadowPrint "Object=" + HEX$(obj(ooff).ob), 260, 125
    ShadowPrint "Total X coord=" + LTRIM$(STR$(GetX2(ooff))), 256, 135
    IF verbose THEN
      ShadowPrint "Map Offset=" + HEX$(Offset), 256, 145
    END IF

  CASE "nop"

  CASE "nme"
    ShadowPrint "Enemy Num:" + LTRIM$(STR$(noff)) + "/" + LTRIM$(STR$(numnme)), 256, 101
    ShadowPrint "Xpos=" + LTRIM$(STR$(nme(noff).xs)), 256, 109
    ShadowPrint "Ypos=" + HEX$(nme(noff).yp), 256, 117
    ShadowPrint "Object=" + HEX$(nme(noff).ob AND 63), 256, 125
    IF verbose THEN
      ShadowPrint "Nme Offset=" + HEX$(nmeOffset), 256, 145
    END IF

  CASE "choose"
    IF verbose THEN
    
      ShadowPrint "Map Offset=" + HEX$(Offset), 256, 101
      ShadowPrint "Pointer Off=" + HEX$(PointOff), 256, 107
    
      ShadowPrint "Nme Offset=" + HEX$(nmeOffset), 256, 113
      ShadowPrint "NmePntrOff=" + HEX$(nmePointOff), 256, 119
    
      ShadowPrint "Map Number=" + HEX$(TheMap), 256, 127
 
      IF StrongEnemy = 0 THEN
        ShadowPrint "Weak Enemy", 256, 133
      ELSE
        ShadowPrint "Strong Enemy", 256, 133
      END IF

      ShadowPrint HEX$(DaSet) + ":", 256, 139
      SELECT CASE DaSet
        CASE 0: Text$ = "West Hyrule"
        CASE 1: Text$ = "Death Mtn."
        CASE 2: Text$ = "East Hyrule"
        CASE 3: Text$ = "Maze Island"
        CASE 4: Text$ = "Towns"
        CASE 6: Text$ = "Palaces 1,2,5"
        CASE 7: Text$ = "Palaces 3,4,6"
        CASE 8: Text$ = "Great Palace"
      END SELECT
      ShadowPrint Text$, 262, 139

      ShadowPrint "Rombank=" + HEX$(rombank), 256, 145
   
      NewMap = 0
      NewMapOff = rombank * 16384 + &H72B + DaMap * 4
      IF DaSet AND 1 THEN NewMapOff = NewMapOff + &H1ADD
 
      ShadowPrint "Layout: " + HEX$(NewMapOff), 256, 151

      DQBpeek VARSEG(NewMap), VARPTR(NewMap), NewMapOff + 2, 1
      ShadowPrint hex2$(NewMap \ 4), 266, 157
 
      DQBpeek VARSEG(NewMap), VARPTR(NewMap), NewMapOff, 1
      ShadowPrint hex2$(NewMap \ 4), 256, 163
 
      DQBpeek VARSEG(NewMap), VARPTR(NewMap), NewMapOff + 3, 1
      ShadowPrint hex2$(NewMap \ 4), 276, 163

      ShadowPrint hex2$(DaMap + 0), 266, 163

      DQBpeek VARSEG(NewMap), VARPTR(NewMap), NewMapOff + 1, 1
      ShadowPrint hex2$(NewMap \ 4), 266, 169

      '<ADDED>
      ShadowPrint hex2$(NewMap + 0), 266, 177

      DQBpeek VARSEG(NewMap), VARPTR(NewMap), NewMapOff, 1
      ShadowPrint hex2$(NewMap + 0), 256, 183

      DQBpeek VARSEG(NewMap), VARPTR(NewMap), NewMapOff + 3, 1
      ShadowPrint hex2$(NewMap + 0), 276, 183

      ShadowPrint hex2$(DaMap * 4), 266, 183

      DQBpeek VARSEG(NewMap), VARPTR(NewMap), NewMapOff + 1, 1
      ShadowPrint hex2$(NewMap + 0), 266, 189
      '</added>


      DQBpeek VARSEG(NewMap), VARPTR(NewMap), NewMapOff + 2, 1
      ShadowPrint hex2$(NewMap AND 3), 302, 157

      DQBpeek VARSEG(NewMap), VARPTR(NewMap), NewMapOff, 1
      ShadowPrint hex2$(NewMap AND 3), 292, 163

      DQBpeek VARSEG(NewMap), VARPTR(NewMap), NewMapOff + 3, 1
      ShadowPrint hex2$(NewMap AND 3), 312, 163

      DQBpeek VARSEG(NewMap), VARPTR(NewMap), NewMapOff + 1, 1
      ShadowPrint hex2$(NewMap AND 3), 302, 169
  
    ELSE
 
      ShadowPrint "Map Number=" + HEX$(TheMap), 256, 127
  
      IF StrongEnemy = 0 THEN
        ShadowPrint "Weak Enemy", 256, 133
      ELSE
        ShadowPrint "Strong Enemy", 256, 133
      END IF

      NewMap = 0
      NewMapOff = rombank * 16384 + &H72B + DaMap * 4
      IF DaSet AND 1 THEN NewMapOff = NewMapOff + &H1ADD
   
      ShadowPrint "Layout: " + HEX$(NewMapOff), 256, 151

      DQBpeek VARSEG(NewMap), VARPTR(NewMap), NewMapOff + 2, 1
      ShadowPrint HEX$(NewMap \ 4), 266, 157

      DQBpeek VARSEG(NewMap), VARPTR(NewMap), NewMapOff, 1
      ShadowPrint HEX$(NewMap \ 4), 256, 163

      DQBpeek VARSEG(NewMap), VARPTR(NewMap), NewMapOff + 3, 1
      ShadowPrint HEX$(NewMap \ 4), 276, 163

      ShadowPrint HEX$(DaMap), 266, 163

      DQBpeek VARSEG(NewMap), VARPTR(NewMap), NewMapOff + 1, 1
      ShadowPrint HEX$(NewMap \ 4), 266, 169
    END IF


END SELECT

END SUB

SUB DrawBox (xoff, ooff)

x1 = GetX2(ooff) - xoff

x1 = x1 * 16
y1 = obj(ooff).yp
Z = obj(ooff).ob MOD 16
IF y1 = &HD THEN
  SELECT CASE Z
    CASE 15: y1 = 0
    CASE IS < 8: y1 = 11 - Z
    CASE IS > 7: y1 = Z - 7
  END SELECT
END IF
IF y1 = &HE THEN y1 = 0
IF y1 = &HF THEN
  Z = obj(ooff).ob
  SELECT CASE Z
    CASE &H20 TO &H2F
      y1 = 10
    CASE &H30 TO &H3F
      y1 = 9 - (Z - &H30)
      IF y1 < 0 THEN y1 = 0
    CASE &H40 TO &H4F
      y1 = 8
    CASE &H50
      y1 = 9
    CASE ELSE
      y1 = 12
  END SELECT
END IF
y1 = y1 * 16

IF x1 > 255 OR x1 < 0 THEN EXIT SUB


DQBbox 0, x1, y1, x1 + 15, y1 + 15, 6

END SUB

SUB DrawDialogBox
  DQBboxf 0, 24, 16, 230, 60, 5          'Make Dialog box
  DQBbox 0, 24, 16, 230, 60, 8           'and border
END SUB

SUB DrawMap (xoff AS INTEGER, startx, endx, pxloff)

FOR y = 0 TO 12
  FOR x = startx TO endx
    Z = map(xoff + x, y)
    DrawTile x, y, pxloff, Z
  NEXT
NEXT

DrawNme xoff, pxloff

DQBboxf 1, 256, 0, 319, 199, 0

DQBwait 1
DQBcopyTransLayer 1, 0

END SUB

SUB DrawNme (xoff AS INTEGER, pxloff AS INTEGER)

CONST nul = 18
CONST inf = 53
CONST gli = 100

FOR x = 0 TO numobj
  IF obj(x).yp < 13 THEN
    SELECT CASE obj(x).ob
      CASE 5
        IF rombank <> 3 THEN
          BlitNme GetX2(x) - xoff, 8, pxloff, 3
          BlitNme GetX2(x) - xoff, 9, pxloff, 4
          BlitNme GetX2(x) - xoff, 10, pxloff, 3
        END IF
      CASE 6
        IF rombank = 4 THEN
          BlitNme GetX2(x) - xoff, 8, pxloff, 3
          BlitNme GetX2(x) - xoff, 9, pxloff, 4
          BlitNme GetX2(x) - xoff, 10, pxloff, 3
        END IF
      CASE IS >= 256
        IF obj(x).ob < &H116 THEN
          BlitNme GetX2(x) - xoff, obj(x).yp, pxloff, obj(x).ob - 256 + 55
        ELSE
          BlitNme GetX2(x) - xoff, obj(x).yp, pxloff, 100
        END IF

    END SELECT
  END IF
  IF obj(x).yp = 15 AND obj(x).ob = &H50 THEN
    DrawTile GetX2(x) - xoff, 8, pxloff, 111
    DrawTile GetX2(x) - xoff + 1, 8, pxloff, 111
    DrawTile GetX2(x) - xoff, 10, pxloff, 111
    DrawTile GetX2(x) - xoff + 1, 10, pxloff, 111
  END IF
NEXT

FOR x = 0 TO numnme
  y = nme(x).yp
  IF y = 0 THEN y = -1
  y = y + 2
  IF y > 12 THEN y = 13
  xp = nme(x).xs
  IF xp - 16 < xoff OR xp >= xoff THEN
  Z = nme(x).ob
  SELECT CASE rombank
   CASE 1
    SELECT CASE Z
       CASE &H0: BlitNme xp - xoff, y, pxloff, 1         'Fairy
       CASE &H1: BlitNme xp - xoff, y, pxloff, 2         'Red Jar
       CASE &H2: BlitNme xp - xoff, y, pxloff, 3         'Locked Door
                 BlitNme xp - xoff, y + 1, pxloff, 4     '
                 BlitNme xp - xoff, y + 2, pxloff, 3     '
       CASE &H3: BlitNme xp - xoff, y, pxloff, 5         'Myu (spiked blob)
       CASE &H4: BlitNme xp - xoff, y, pxloff, 6         'Bot (red blob)
       CASE &H5: BlitNme xp - xoff, y, pxloff, 7         'Bit (blue blob)
       CASE &H6: BlitNme xp - xoff, y, pxloff, 8         'Moa (floating eye)
       CASE &H7: BlitNme xp - xoff, y, pxloff, 9         'Ache (blue bat)
       CASE &H8, &H9: DrawTile xp - xoff, y, pxloff, cra 'Crash
       CASE &HA: BlitNme xp - xoff, y, pxloff, 11        'Red Ache (fire bat)
                 BlitNme xp - xoff, y + 1, pxloff, 12    '
       CASE &HB: BlitNme xp - xoff, y, pxloff, 13        'Bubbles
       CASE &HC: BlitNme xp - xoff, y, pxloff, 14        'Rocks
       CASE &HD: BlitNme xp - xoff, y, pxloff, 15        'Red Deeler (spider)
       CASE &HE: BlitNme xp - xoff, y, pxloff, 16        'Blue Deeler (spider)
       CASE &HF: BlitNme xp - xoff, y, pxloff, 17        'Infinate Dinoskulls
                 BlitNme xp - xoff, y + 1, pxloff, 53
      CASE &H10: BlitNme xp - xoff, y, pxloff, 17        'Dinoskull
      CASE &H11: BlitNme xp - xoff, y, pxloff, 19        'Octorok
      CASE &H12: BlitNme xp - xoff, y, pxloff, 19        'Walking Octorok
                 BlitNme xp - xoff, y + 1, pxloff, 20    '
      CASE &H13: DrawTile xp - xoff, y, pxloff, 111      'Elevator
                 DrawTile xp - xoff + 1, y, pxloff, 111  '
                 DrawTile xp - xoff, y + 2, pxloff, 111  '
                 DrawTile xp - xoff + 1, y + 2, pxloff, 111
      CASE &H14: BlitNme xp - xoff, y, pxloff, 24        'Orange Moblin
                 BlitNme xp - xoff, y + 1, pxloff, 25    '
                 BlitNme xp - xoff - 1, y, pxloff, 26    '
                 BlitNme xp - xoff + 1, y, pxloff, 27    '
      CASE &H15: BlitNme xp - xoff, y, pxloff, 28        'Red Moblin
                 BlitNme xp - xoff, y + 1, pxloff, 29    '
                 BlitNme xp - xoff - 1, y + 1, pxloff, 30'
      CASE &H16: BlitNme xp - xoff, y, pxloff, 31        'Blue Moblin
                 BlitNme xp - xoff, y + 1, pxloff, 32    '
                 BlitNme xp - xoff - 1, y, pxloff, 33    '
                 BlitNme xp - xoff + 1, y, pxloff, 34    '
      CASE &H17: BlitNme xp - xoff - 1, y, pxloff, 21    'Orange Diara
                 BlitNme xp - xoff, y, pxloff, 22        '
                 BlitNme xp - xoff, y + 1, pxloff, 23    '
      CASE &H18: BlitNme xp - xoff - 1, y, pxloff, 35    'Red Diara
                 BlitNme xp - xoff, y, pxloff, 36        '
                 BlitNme xp - xoff, y + 1, pxloff, 37    '
      CASE &H19: BlitNme xp - xoff, y, pxloff, 38        'Orange Goriya
                 BlitNme xp - xoff, y + 1, pxloff, 39    '
      CASE &H1A: BlitNme xp - xoff, y, pxloff, 40        'Red Goriya
                 BlitNme xp - xoff, y + 1, pxloff, 41    '
      CASE &H1B: BlitNme xp - xoff, y, pxloff, 42        'Blue Goriya
                 BlitNme xp - xoff, y + 1, pxloff, 43    '
      CASE &H1C: BlitNme xp - xoff, y, pxloff, 44        'Lowder (beetle)
      CASE &H1D: BlitNme xp - xoff, y, pxloff, 45        'Infinate Moby
                 BlitNme xp - xoff, y + 1, pxloff, 53    '
      CASE &H1E: BlitNme xp - xoff, y, pxloff, 45        'Single Moby
      CASE &H1F: BlitNme xp - xoff, y, pxloff, 51        'Jumping Beaver
      CASE &H20: BlitNme xp - xoff, y, pxloff, 47        'Geldarm
                 BlitNme xp - xoff, y + 1, pxloff, 48    '
                 BlitNme xp - xoff, y + 2, pxloff, 49    '
                 BlitNme xp - xoff, y + 3, pxloff, 50    '
                 BlitNme xp - xoff, y + 4, pxloff, 48    '
      CASE &H21: BlitNme xp - xoff, y, pxloff, 24        'Endless Moblins
                 BlitNme xp - xoff, y + 1, pxloff, 25    '
                 BlitNme xp - xoff + 1, y, pxloff, 52    '
                 BlitNme xp - xoff + 1, y, pxloff, 53    '
      CASE &H22: BlitNme xp - xoff, y, pxloff, 24        'Idiot Moblin
                 BlitNme xp - xoff, y + 1, pxloff, 25    '
                 BlitNme xp - xoff + 1, y, pxloff, 52    '
      CASE &H23 TO &H3F: DrawTile xp - xoff, y, pxloff, cra  'Crash
      CASE ELSE: BlitNme xp - xoff, y, pxloff, 0         'Strong Enemy Icon
    END SELECT
   CASE 2
    SELECT CASE Z
       CASE &H0: BlitNme xp - xoff, y, pxloff, 1         'Fairy
       CASE &H1: BlitNme xp - xoff, y, pxloff, 2         'Red Jar
       CASE &H2: BlitNme xp - xoff, y, pxloff, 3         'Locked Door
                 BlitNme xp - xoff, y + 1, pxloff, 4     '
                 BlitNme xp - xoff, y + 2, pxloff, 3     '
       CASE &H3: BlitNme xp - xoff, y, pxloff, 5         'Myu (spiked blob)
       CASE &H4: BlitNme xp - xoff, y, pxloff, 6         'Bot (red blob)
       CASE &H5: BlitNme xp - xoff, y, pxloff, 7         'Bit (blue blob)
       CASE &H6: BlitNme xp - xoff, y, pxloff, 77        'Blue Moa
       CASE &H7: BlitNme xp - xoff, y, pxloff, 9         'Ache (blue bat)
       CASE &H8, &H9: DrawTile xp - xoff, y, pxloff, cra 'Crash
       CASE &HA: BlitNme xp - xoff, y, pxloff, 11        'Red Ache (fire bat)
                 BlitNme xp - xoff, y + 1, pxloff, 12    '
       CASE &HB: BlitNme xp - xoff, y, pxloff, 13        'Bubbles
       CASE &HC: BlitNme xp - xoff, y, pxloff, 78        'Floating Voodoo dolls
       CASE &HD: BlitNme xp - xoff, y, pxloff, 15        'Red Deeler (spider)
       CASE &HE: BlitNme xp - xoff, y, pxloff, 16        'Blue Deeler (spider)
       CASE &HF: BlitNme xp - xoff, y, pxloff, 17        'Infinate Dinoskulls
                 BlitNme xp - xoff, y + 1, pxloff, 53
      CASE &H10: BlitNme xp - xoff, y, pxloff, 18        'Dinoskull
      CASE &H11: BlitNme xp - xoff, y, pxloff, 79        'Blue Octorok
      CASE &H12: BlitNme xp - xoff, y, pxloff, 79        'Blue Walking Octorok
                 BlitNme xp - xoff, y + 1, pxloff, 20    '
      CASE &H13: DrawTile xp - xoff, y, pxloff, 111      'Elevator
                 DrawTile xp - xoff + 1, y, pxloff, 111  '
                 DrawTile xp - xoff, y + 2, pxloff, 111  '
                 DrawTile xp - xoff + 1, y + 2, pxloff, 111
      CASE &H14: BlitNme xp - xoff, y, pxloff, 80        'Orange Moblin
                 BlitNme xp - xoff, y + 1, pxloff, 81    '
      CASE &H15: BlitNme xp - xoff, y, pxloff, 82        'Open/close eye
      CASE &H16: BlitNme xp - xoff, y, pxloff, 83        'Blue Moblin
      CASE &H17: BlitNme xp - xoff, y, pxloff, 84        'that bee thingy
      CASE &H18: BlitNme xp - xoff, y, pxloff, 85        'Basilisk
                 BlitNme xp - xoff + 1, y, pxloff, 86    '
      CASE &H19: BlitNme xp - xoff, y + 1, pxloff, 87    'Scorpion
                 BlitNme xp - xoff, y, pxloff, 88        '
                 BlitNme xp - xoff + 1, y + 1, pxloff, 89'
      CASE &H1A: BlitNme xp - xoff, y, pxloff, 90        'Red Lizardman
                 BlitNme xp - xoff, y + 1, pxloff, 91    '
      CASE &H1B: BlitNme xp - xoff, y, pxloff, 92        'Yellow Lizardman
                 BlitNme xp - xoff, y + 1, pxloff, 93    '
                 BlitNme xp - xoff + 1, y, pxloff, 94    '
      CASE &H1C: BlitNme xp - xoff, y, pxloff, 95        'Blue Lizardman
                 BlitNme xp - xoff, y + 1, pxloff, 96    '
                 BlitNme xp - xoff - 1, y, pxloff, 97    '
      CASE &H1D: BlitNme xp - xoff + 1, y, pxloff, 98    'Stonethrower
                 BlitNme xp - xoff, y, pxloff, 99        '
      CASE &H1E TO &H3F: DrawTile xp - xoff, y, pxloff, cra'Crash
      CASE ELSE: BlitNme xp - xoff, y, pxloff, 0         'Strong Enemy Icon
    END SELECT
   CASE 3
    SELECT CASE Z
       CASE &H0: BlitNme xp - xoff, y, pxloff, 1         'Fairy
       CASE &H1: BlitNme xp - xoff, y, pxloff, 55        'Candle
       CASE &H2: BlitNme xp - xoff, y, pxloff, 3         'Glitched Locked Door
                 BlitNme xp - xoff, y + 1, pxloff, 4     '
                 BlitNme xp - xoff, y + 2, pxloff, 3     '
       CASE &H3: BlitNme xp - xoff, y, pxloff, 9         'Eye of Ganon
       CASE &H4: BlitNme xp - xoff, y, pxloff, 6         'Bot (blue blob)
       CASE &H5: BlitNme xp - xoff, y, pxloff, 7         'Bit (red blob)
       CASE &H6: BlitNme xp - xoff, y, pxloff, 77        'Blue Moa
       CASE &H7: BlitNme xp - xoff, y, pxloff, 9         'Ache (blue bat)
       CASE &H8: BlitNme xp - xoff, y, pxloff, 101       'Gold Girl
                 BlitNme xp - xoff, y + 1, pxloff, 102
       CASE &H9: BlitNme xp - xoff, y, pxloff, 103       'Red Girl
                 BlitNme xp - xoff, y + 1, pxloff, 104
       CASE &HA: BlitNme xp - xoff, y, pxloff, 105       'Talking Red Ache
       CASE &HB: BlitNme xp - xoff, y, pxloff, 6         'Talking Bot
       CASE &HC: BlitNme xp - xoff, y, pxloff, 112       'Sign
       CASE &HD: BlitNme xp - xoff, y, pxloff, 106       'Blue Old Lady
                 BlitNme xp - xoff, y + 1, pxloff, 107
       CASE &HE: BlitNme xp - xoff, y, pxloff, 108       'Blue Man
                 BlitNme xp - xoff, y + 1, pxloff, 109
       CASE &HF: BlitNme xp - xoff, y, pxloff, 110       'Magician
                 BlitNme xp - xoff, y + 1, pxloff, 111
      CASE &H10: BlitNme xp - xoff, y + 1, pxloff, 113   'Kid
      CASE &H11: BlitNme xp - xoff, y, pxloff, 114       'Blue Lady
                 BlitNme xp - xoff, y + 1, pxloff, 115
      CASE &H12: BlitNme xp - xoff, y, pxloff, 116       'Red Old Lady
                 BlitNme xp - xoff, y + 1, pxloff, 117
      CASE &H13: BlitNme xp - xoff, y - 1, pxloff, 118   'Red Man+Door
                 BlitNme xp - xoff, y, pxloff, 119
                 BlitNme xp - xoff, y + 1, pxloff, 120
                 BlitNme xp - xoff, y, pxloff, 121
                 BlitNme xp - xoff, y + 1, pxloff, 122
      CASE &H14: BlitNme xp - xoff, y - 1, pxloff, 118   'Blue Lady+Door
                 BlitNme xp - xoff, y, pxloff, 119
                 BlitNme xp - xoff, y + 1, pxloff, 120
                 BlitNme xp - xoff, y, pxloff, 123
                 BlitNme xp - xoff, y + 1, pxloff, 124
      CASE &H15: BlitNme xp - xoff, y - 1, pxloff, 118   'Blue Old Lady+Door
                 BlitNme xp - xoff, y, pxloff, 119
                 BlitNme xp - xoff, y + 1, pxloff, 120
                 BlitNme xp - xoff, y, pxloff, 125
                 BlitNme xp - xoff, y + 1, pxloff, 126
      CASE &H16: BlitNme xp - xoff, y - 1, pxloff, 118   'Red Girl+Door
                 BlitNme xp - xoff, y, pxloff, 119
                 BlitNme xp - xoff, y + 1, pxloff, 120
                 BlitNme xp - xoff, y, pxloff, 103
                 BlitNme xp - xoff, y + 1, pxloff, 104
      CASE &H17: BlitNme xp - xoff, y, pxloff, 103       'Life Girl
                 BlitNme xp - xoff, y + 1, pxloff, 104
      CASE &H18: BlitNme xp - xoff, y, pxloff, 127       'Magic old lady
                 BlitNme xp - xoff, y + 1, pxloff, 128
      CASE &H19: BlitNme xp - xoff, y, pxloff, 129       'Blue Busy Man
                 BlitNme xp - xoff, y + 1, pxloff, 130
      CASE &H1A: BlitNme xp - xoff, y, pxloff, 131       'HELLO!
                 BlitNme xp - xoff, y + 1, pxloff, 132
      CASE &H1B: BlitNme xp - xoff, y, pxloff, 133       'YELLO YOUNG FELLOW.
                 BlitNme xp - xoff, y + 1, pxloff, 134
      CASE &H1C: BlitNme xp - xoff, y, pxloff, 135       'Brainless Girl
                 BlitNme xp - xoff, y + 1, pxloff, 136
      CASE &H1D: BlitNme xp - xoff, y, pxloff, 129       'Walking Blue Man
                 BlitNme xp - xoff, y + 1, pxloff, 130
      CASE &H1E: BlitNme xp - xoff, y, pxloff, 137       'Guy
                 BlitNme xp - xoff, y + 1, pxloff, 138
      CASE &H1F: BlitNme xp - xoff, y, pxloff, 137       'Slower Guy
                 BlitNme xp - xoff, y + 1, pxloff, 138
      CASE &H20: BlitNme xp - xoff, y, pxloff, 135       'Walking Blue Girl
                 BlitNme xp - xoff, y + 1, pxloff, 136
      CASE &H21: BlitNme xp - xoff, y, pxloff, 112       'Mirror
      CASE &H22: BlitNme xp - xoff, y, pxloff, 112       'Sign
      'CASE &H23: BlitNme xp - xoff, y, pxloff, 18        'Nothing?
      CASE &H24: DrawTile xp - xoff, y, pxloff, cra      'Crash
      CASE &H25: DrawTile xp - xoff, y, pxloff, cra      'Crash
      CASE &H26: DrawTile xp - xoff, y, pxloff, cra      'Crash

      CASE &H3F TO &H3F: DrawTile xp - xoff, y, pxloff, cra'Crash
      CASE ELSE: BlitNme xp - xoff, y, pxloff, 0         'Strong Enemy Icon
    END SELECT
   CASE 4
   SELECT CASE DaSet
    CASE 6
     SELECT CASE Z
       CASE &H0: BlitNme xp - xoff, y, pxloff, 1         'Fairy
       CASE &H1: BlitNme xp - xoff, y, pxloff, 55        'Candle
       CASE &H2: BlitNme xp - xoff, y, pxloff, 3         'Locked Door
                 BlitNme xp - xoff, y + 1, pxloff, 4     '
                 BlitNme xp - xoff, y + 2, pxloff, 3     '
       CASE &H3: BlitNme xp - xoff, y, pxloff, 5         'Myu (spiked blob)
       CASE &H4: BlitNme xp - xoff, y, pxloff, 6         'Bot (blue blob)
       CASE &H5: BlitNme xp - xoff, y, pxloff, 147       'Hidden Red Jar
       CASE &H6: BlitNme xp - xoff, y, pxloff, 141       'Slow Bubble
       CASE &H7: BlitNme xp - xoff, y, pxloff, 142       'Orange Moa
       CASE &H8: BlitNme xp - xoff, y, pxloff, 139       'Falling Blocks
          FOR tx = 22 TO 31
            BlitNme tx - xoff, 0, pxloff, 140
          NEXT
       CASE &H9: BlitNme xp - xoff, y, pxloff, 140       'Falling Block
       CASE &HA: BlitNme xp - xoff, y, pxloff, 145       'Unicorn Head
       CASE &HB: BlitNme xp - xoff, y, pxloff, 143       'Infinate Rat Heads
                 BlitNme xp - xoff, y + 1, pxloff, 144
                 BlitNme xp - xoff, y + 2, pxloff, 53
       CASE &HC: BlitNme xp - xoff, y, pxloff, 143       'Rat Head
                 BlitNme xp - xoff, y + 1, pxloff, 144   '
       CASE &HD: BlitNme xp - xoff, y + 1, pxloff, 146   'Dropper
       CASE &HE: BlitNme xp - xoff, y, pxloff, 148       'Fast Bubble
                 BlitNme xp - xoff, y + 1, pxloff, 150
       CASE &HF: BlitNme xp - xoff, y, pxloff, 17        'Infinate Dinoskull
                 BlitNme xp - xoff, y + 1, pxloff, 53
      CASE &H10: BlitNme xp - xoff, y, pxloff, 17        'Single Dinoskull
      CASE &H11: BlitNme xp - xoff, y, pxloff, 149       'Rope
      CASE &H12: BlitNme xp - xoff, y, pxloff, 149       'Walking Rope
                 BlitNme xp - xoff, y + 1, pxloff, 20    '
      CASE &H13: DrawTile xp - xoff, y, pxloff, 111      'Elevator
                 DrawTile xp - xoff + 1, y, pxloff, 111  '
                 DrawTile xp - xoff, y + 2, pxloff, 111  '
                 DrawTile xp - xoff + 1, y + 2, pxloff, 111
      CASE &H14: BlitNme xp - xoff, y, pxloff, 153       'Put Crystal
        BlitNme ((xp \ 16) * 16 + 8 - xoff), 4, pxloff, 151
      CASE &H15: BlitNme xp - xoff, y, pxloff, 153       'Crystal
        BlitNme ((xp \ 16) * 16 + 8 - xoff), 4, pxloff, 152
      CASE &H16: BlitNme xp - xoff, y, pxloff, 154       'Left Shooter
      CASE &H17: BlitNme xp - xoff, y, pxloff, 155       'Right Shooter
      CASE &H18: BlitNme xp - xoff, y, pxloff, 156       'Orange Ironknuckle
                 BlitNme xp - xoff, y + 1, pxloff, 157
      CASE &H19: BlitNme xp - xoff, y, pxloff, 158       'Red Ironknuckle
                 BlitNme xp - xoff, y + 1, pxloff, 159
      CASE &H1A: BlitNme xp - xoff, y, pxloff, 160       'Blue Ironknuckle
                 BlitNme xp - xoff, y + 1, pxloff, 161
      CASE &H1B: BlitNme xp - xoff, y, pxloff, 162       'Infinate Wolfheads
                 BlitNme xp - xoff, y + 1, pxloff, 53
      CASE &H1C: BlitNme xp - xoff, y, pxloff, 162       'Single Wolfhead
      CASE &H1D: BlitNme xp - xoff, y, pxloff, 163       'Wizrobe
                 BlitNme xp - xoff, y + 1, pxloff, 164
      CASE &H1E: BlitNme xp - xoff, y, pxloff, 165       'Red thing that
                 BlitNme xp - xoff, y + 1, pxloff, 166   'throws clubs at you
                 BlitNme xp - xoff + 1, y, pxloff, 167
      CASE &H1F: BlitNme xp - xoff, y, pxloff, 168       'Red Stalfos
                 BlitNme xp - xoff, y + 1, pxloff, 169
      CASE &H20: BlitNme xp - xoff, y, pxloff, 170       'Horsehead
                 BlitNme xp - xoff, y + 1, pxloff, 171
                 BlitNme xp - xoff, y + 2, pxloff, 172
      CASE &H21                                          'HelmetHead/Boss5
        IF DaMap < &H23 THEN
          BlitNme xp - xoff, y - 1, pxloff, 173   'Helmethead
          BlitNme xp - xoff, y, pxloff, 174
          BlitNme xp - xoff, y + 1, pxloff, 175
        ELSE
          BlitNme xp - xoff, y, pxloff, 179       'Boss5
          BlitNme xp - xoff, y + 1, pxloff, 180
          BlitNme xp - xoff, y + 2, pxloff, 181
          BlitNme xp - xoff + 1, y, pxloff, 182
          BlitNme xp - xoff + 1, y + 1, pxloff, 183
          BlitNme xp - xoff + 1, y + 2, pxloff, 184
          BlitNme xp - xoff - 1, y + 1, pxloff, 185

        END IF
      CASE &H22: BlitNme xp - xoff, y, pxloff, 176       'Helmethead's head
      CASE &H23: BlitNme xp - xoff, y, pxloff, 177       'Blue Stalfos
                 BlitNme xp - xoff, y + 1, pxloff, 178   '
      CASE &H24: DrawTile xp - xoff, y, pxloff, cra      'Crash
      CASE &H25: BlitNme xp - xoff, y, pxloff, nul       'Null?
      CASE &H26 TO &H3F: DrawTile xp - xoff, y, pxloff, cra'Crash
      CASE ELSE: BlitNme xp - xoff, y, pxloff, 0         'Strong Enemy Icon
     END SELECT
    CASE 7
     SELECT CASE Z
       CASE &H0: BlitNme xp - xoff, y, pxloff, 1         'Fairy
       CASE &H1: BlitNme xp - xoff, y, pxloff, 55        'Candle
       CASE &H2: BlitNme xp - xoff, y, pxloff, 3         'Locked Door
                 BlitNme xp - xoff, y + 1, pxloff, 4     '
                 BlitNme xp - xoff, y + 2, pxloff, 3     '
       CASE &H3: BlitNme xp - xoff, y, pxloff, 5         'Myu (spiked blob)
       CASE &H4: BlitNme xp - xoff, y, pxloff, 6         'Bot (blue blob)
       CASE &H5: BlitNme xp - xoff, y, pxloff, 147       'Hidden Red Jar/enemy
       CASE &H6: BlitNme xp - xoff, y, pxloff, 141       'Bubble
       CASE &H7: BlitNme xp - xoff, y, pxloff, 142       'Orange Moa
       CASE &H8: BlitNme xp - xoff, y, pxloff, 139       'Falling Blocks
          FOR tx = 22 TO 31
            BlitNme tx - xoff, 0, pxloff, 140            'Top Blocks
          NEXT
       CASE &H9: BlitNme xp - xoff, y, pxloff, 140       'Falling Block
       CASE &HA: BlitNme xp - xoff, y, pxloff, 145       'Unicorn Head
       CASE &HB: BlitNme xp - xoff, y, pxloff, 143       'Infinate Rat Heads
                 BlitNme xp - xoff, y + 1, pxloff, 144
                 BlitNme xp - xoff, y + 2, pxloff, 53
       CASE &HC: BlitNme xp - xoff, y, pxloff, 143       'Rat Head
                 BlitNme xp - xoff, y + 1, pxloff, 144   '
       CASE &HD: BlitNme xp - xoff, y + 1, pxloff, 146   'Dropper
       CASE &HE: BlitNme xp - xoff, y, pxloff, 148       'Fast Bubble
                 BlitNme xp - xoff, y + 1, pxloff, 150
       CASE &HF: BlitNme xp - xoff, y, pxloff, nul       'Nul?
      CASE &H10: BlitNme xp - xoff, y, pxloff, 186       'Fire
      CASE &H11: BlitNme xp - xoff, y, pxloff, 149       'Rope (kinda glitchd)
      CASE &H12: BlitNme xp - xoff, y, pxloff, nul       'Nul
      CASE &H13: DrawTile xp - xoff, y, pxloff, 111      'Elevator
                 DrawTile xp - xoff + 1, y, pxloff, 111  '
                 DrawTile xp - xoff, y + 2, pxloff, 111  '
                 DrawTile xp - xoff + 1, y + 2, pxloff, 111
      CASE &H14: BlitNme xp - xoff, y, pxloff, 153       'Put Crystal
        BlitNme ((xp \ 16) * 16 + 8 - xoff), 4, pxloff, 151
      CASE &H15: BlitNme xp - xoff, y, pxloff, 153       'Crystal
        BlitNme ((xp \ 16) * 16 + 8 - xoff), 4, pxloff, 152
      CASE &H16: BlitNme xp - xoff, y, pxloff, 154       'Left Shooter
      CASE &H17: BlitNme xp - xoff, y, pxloff, 155       'Right Shooter
      CASE &H18: BlitNme xp - xoff, y, pxloff, 156       'Orange Ironknuckle
                 BlitNme xp - xoff, y + 1, pxloff, 157
      CASE &H19: BlitNme xp - xoff, y, pxloff, 158       'Red Ironknuckle
                 BlitNme xp - xoff, y + 1, pxloff, 159
      CASE &H1A: BlitNme xp - xoff, y, pxloff, 160       'Blue Ironknuckle
                 BlitNme xp - xoff, y + 1, pxloff, 161
      CASE &H1B: BlitNme xp - xoff, y, pxloff, 162       'Infinate Wolfheads
                 BlitNme xp - xoff, y + 1, pxloff, 53
      CASE &H1C: BlitNme xp - xoff, y, pxloff, 162       'Single Wolfhead
      CASE &H1D: BlitNme xp - xoff, y, pxloff, 187       'Red Wizrobe
                 BlitNme xp - xoff, y + 1, pxloff, 188
      CASE &H1E: BlitNme xp - xoff, y, pxloff, 189       'Blue Axe Thingy
                 BlitNme xp - xoff, y + 1, pxloff, 190   '
      CASE &H1F: BlitNme xp - xoff, y, pxloff, 191       'Armored Red Stalfos
                 BlitNme xp - xoff, y + 1, pxloff, 192
      CASE &H20: BlitNme xp - xoff, y, pxloff, 193       'Mounted Ironknuckle
                 BlitNme xp - xoff, y + 1, pxloff, 194
                 BlitNme xp - xoff + 1, y, pxloff, 195
                 BlitNme xp - xoff + 1, y + 1, pxloff, 196
      CASE &H21                                          'lv6 Snake thingy
          BlitNme xp - xoff, y, pxloff, 197
          BlitNme xp - xoff + 1, y, pxloff, 198
          BlitNme xp - xoff, y + 1, pxloff + 14, 199
          BlitNme xp - xoff, y + 2, pxloff + 12, 199
          BlitNme xp - xoff, y + 3, pxloff + 10, 199
          BlitNme xp - xoff, y + 4, pxloff + 8, 199
          BlitNme xp - xoff, y + 5, pxloff + 10, 199
          BlitNme xp - xoff, y + 6, pxloff + 12, 199
      CASE &H22: BlitNme xp - xoff, y, pxloff, 200       'Big Wizrobe
                 BlitNme xp - xoff, y + 1, pxloff, 201
                 BlitNme xp - xoff, y + 2, pxloff, 202
                 BlitNme xp - xoff + 1, y, pxloff, 203
                 BlitNme xp - xoff + 1, y + 1, pxloff, 204
                 BlitNme xp - xoff + 1, y + 2, pxloff, 205
      CASE &H23: BlitNme xp - xoff, y, pxloff, 206       'Blue Stalfos
                 BlitNme xp - xoff, y + 1, pxloff, 207   '
      CASE &H24: DrawTile xp - xoff, y, pxloff, cra      'Crash
      CASE &H25: BlitNme xp - xoff, y, pxloff, nul       'Null?
      CASE &H26 TO &H3F: DrawTile xp - xoff, y, pxloff, cra'Crash
      CASE ELSE: BlitNme xp - xoff, y, pxloff, 0         'Strong Enemy Icon
     END SELECT
    END SELECT
   END SELECT

 END IF
 
 
  'DrawTile xp - xoff, y, pxloff, 45
NEXT


END SUB

SUB DrawTile (x, y, pxloff, Z)

IF Z < 80 THEN
  x1 = (Z \ 4) * 16
  y1 = (Z MOD 4) * 16
ELSE
  x1 = ((Z - 80) \ 8) * 16
  y1 = ((Z - 80) MOD 8) * 16 + 64
END IF

DQBget 4, x1, y1, x1 + 15, y1 + 15, VARSEG(tilebuf(0)), VARPTR(tilebuf(0))
DQBput 1, x * 16 + pxloff, y * 16, VARSEG(tilebuf(0)), VARPTR(tilebuf(0))

END SUB

FUNCTION GetX2 (objno AS INTEGER)
ex = 0
FOR tx = 0 TO objno
  'ex = (ex \ 16 + 1) * 16
  IF obj(tx - 1).yp = &HE THEN ex = (obj(tx - 1).xs) * 16
  ex = ex + obj(tx).xs
NEXT
GetX2 = ex

END FUNCTION

FUNCTION hex2$ (param AS LONG)
DIM answer$
answer$ = HEX$(param)
IF LEN(answer$) = 1 THEN answer$ = "0" + answer$
hex2$ = answer$
END FUNCTION

SUB nmeDrawBox (xoff, noff)

x1 = nme(noff).xs - xoff

x1 = x1 * 16
y1 = nme(noff).yp
Z = nme(noff).ob MOD 16
y1 = y1 + 2
IF y1 > 12 THEN y1 = 12
y1 = y1 * 16

IF x1 > 255 OR x1 < 0 THEN EXIT SUB

DQBbox 0, x1, y1, x1 + 15, y1 + 15, 6

END SUB

SUB ScrollHandler
  DIM ScrollSpeed, Diff                 'Declare Vars
  Diff = ABS(xd - oxd)                  'Set Diff
  IF Diff < 12 THEN                     'Small Diff?
    ScrollSpeed = 2 ^ (Diff \ 3) + 3    'Calculate the scrolling speed
  ELSE                                  'Big Diff?
    ScrollSpeed = 9                     'Just use 9
  END IF
 
  IF xd < oxd THEN                      'Left of previous position?
    ScrollMapLeft oxd, xd, ScrollSpeed    'Scroll it left
  END IF
  IF xd > oxd THEN                      'Right of previous position?
    ScrollMapRight oxd, xd, ScrollSpeed   'Scroll it Right
  END IF
END SUB

SUB ScrollMapLeft (xoff AS INTEGER, xdest AS INTEGER, ScrollSpeed)

IF ScrollMode = 2 THEN EXIT SUB
IF ScrollMode = 1 AND ScrollSpeed < 16 THEN ScrollSpeed = 16

DIM scrolloff, xsrc
xsrc = xoff


DO
scrolloff = scrolloff + ScrollSpeed
IF scrolloff > 16 THEN
  scrolloff = scrolloff - 16
  xoff = xoff - 1
END IF
IF xoff = xdest THEN EXIT DO

DQBscroll 1, ScrollSpeed, 0

DrawMap xoff, -1, 0, scrolloff

LOOP


END SUB

SUB ScrollMapRight (xoff AS INTEGER, xdest AS INTEGER, ScrollSpeed)
DIM scrolloff, xsrc
xsrc = xoff

IF ScrollMode = 2 THEN EXIT SUB
IF ScrollMode = 1 AND ScrollSpeed < 16 THEN ScrollSpeed = 16

DO
scrolloff = scrolloff + ScrollSpeed
IF scrolloff > 16 THEN
  scrolloff = scrolloff - 16
  xoff = xoff + 1
END IF
IF xoff = xdest THEN EXIT DO

DQBscroll 1, -ScrollSpeed, 0

DrawMap xoff, 15, 17, -scrolloff

LOOP


END SUB

SUB ShadowPrint (Text$, x, y)

DQBprint 0, Text$, x + 1, y, 1
DQBprint 0, Text$, x + 1, y + 1, 1
DQBprint 0, Text$, x, y + 1, 1
DQBprint 0, Text$, x, y, 7

END SUB

